Imports System.Drawing.Drawing2D
Public Class ColorLabel
    Inherits System.Windows.Forms.Label

    Private m_BMP As Bitmap = Nothing
    Private m_TextColor As Color = Color.White

    Public Sub New()
        Me.BackColor = System.Drawing.Color.RoyalBlue
        Me.ForeColor = System.Drawing.Color.White
        Me.Size = New System.Drawing.Size(100, 16)
        Me.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        Me.SetStyle(ControlStyles.DoubleBuffer _
        Or ControlStyles.UserPaint _
        Or ControlStyles.AllPaintingInWmPaint, _
        True)
    End Sub


    Property TextColor() As Color
        Get
            Return m_TextColor
        End Get
        Set(ByVal value As Color)
            m_TextColor = value
            m_BMP = Nothing
            Invalidate()
        End Set
    End Property
    Protected Overrides Sub OnPaint(ByVal pe As System.Windows.Forms.PaintEventArgs)
        'MyBase.OnPaint(pe)
        Dim Rect As New Rectangle(0, 0, Me.Width, Me.Height)
        'Benutzerdefinierten Zeichnungscode hier einfgen
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            If Me.Enabled Then
                Dim BackBrush As New LinearGradientBrush(Rect, Me.ForeColor, Me.BackColor, 115.0F)
                g.FillRectangle(BackBrush, Rect)
                Using ForeBrush As New SolidBrush(m_TextColor)
                    g.DrawString(Me.Text, Me.Font, ForeBrush, 2, 2)
                End Using
            Else
                Dim BackBrush As New LinearGradientBrush(Rect, Color.White, Color.LightGray, 115.0F)
                g.FillRectangle(BackBrush, Rect)
                Using ForeBrush As New SolidBrush(Color.DarkGray)
                    g.DrawString(Me.Text, Me.Font, ForeBrush, 2, 2)
                End Using
            End If


        End If
        pe.Graphics.DrawImage(m_BMP, Rect)
    End Sub
    Protected Overrides Sub OnResize(ByVal e As System.EventArgs)
        MyBase.OnResize(e)
        m_BMP = Nothing
        Invalidate()
    End Sub

    Protected Overrides Sub OnAutoSizeChanged(ByVal e As System.EventArgs)
        If Me.AutoSize Then
            Me.AutoSize = False
        End If
    End Sub

    Private Sub ColorLabel_BackColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.BackColorChanged
        m_BMP = Nothing
        Invalidate()
    End Sub

    Private Sub ColorLabel_ForeColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ForeColorChanged
        m_BMP = Nothing
        Invalidate()
    End Sub

    Private Sub DescriptionLabel_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.TextChanged
        m_BMP = Nothing
        Invalidate()
    End Sub
    Protected Overrides Sub OnEnabledChanged(ByVal e As System.EventArgs)
        MyBase.OnEnabledChanged(e)
        m_BMP = Nothing
        Invalidate()
    End Sub
End Class
