Imports System.Xml
Public Class EKGBefund
    Inherits BefundTextEintrag

    Private m_LageTyp As EKGLageTypen = EKGLageTypen.Linkstyp
    Private m_AbsoluteArrhythmie As Boolean = False
    Private m_Frequenz As Integer = 72
    Private m_SelfEdited As Boolean = False

    Public Event SelfEdited_Changed()
    Public Event TextChanged()
    Property SelfEdited() As Boolean
        Get
            Return m_SelfEdited
        End Get
        Set(ByVal value As Boolean)
            If m_SelfEdited <> value Then
                m_SelfEdited = value
                RaiseEvent SelfEdited_Changed()
            End If
        End Set
    End Property
    Property LageTyp() As EKGLageTypen
        Get
            Return m_LageTyp
        End Get
        Set(ByVal value As EKGLageTypen)
            If m_LageTyp <> value Then
                m_LageTyp = value
                CreateNewText()
            End If
        End Set
    End Property
    Property AbsoluteArrhythmie() As Boolean
        Get
            Return m_AbsoluteArrhythmie
        End Get
        Set(ByVal value As Boolean)
            If m_AbsoluteArrhythmie <> value Then
                m_AbsoluteArrhythmie = value
                CreateNewText()
            End If
        End Set
    End Property
    Property Frequenz() As Integer
        Get
            Return m_Frequenz
        End Get
        Set(ByVal value As Integer)
            If m_Frequenz <> value Then
                m_Frequenz = value
                CreateNewText()
            End If
        End Set
    End Property

    Public Sub New(ByVal Parent As BefundTextEintragsListe)
        MyBase.New(Parent)
        m_Kategorie = "EKG"
        CreateNewText()
    End Sub
    Public Sub New(ByVal Parent As BefundTextEintragsListe, ByVal Nd As XmlNode)
        MyBase.New(Parent, Nd)
        m_LageTyp = CType(CInt(Nd.Attributes("LageTyp").Value), EKGLageTypen)
        m_AbsoluteArrhythmie = CBool(Nd.Attributes("AbsoluteArrhythmie").Value)
        m_SelfEdited = CBool(Nd.Attributes("SelfEdited").Value)
        m_Frequenz = CInt(Nd.Attributes("Frequenz").Value)
    End Sub
    Public Overrides Sub Write_XML(ByVal Writer As XmlTextWriter)
        MyBase.Write_XML(Writer)
        Writer.WriteAttributeString("AbsoluteArrhythmie", m_AbsoluteArrhythmie.ToString)
        Writer.WriteAttributeString("SelfEdited", m_SelfEdited.ToString)
        Writer.WriteAttributeString("Frequenz", m_Frequenz.ToString)
        Writer.WriteAttributeString("LageTyp", CInt(m_LageTyp).ToString)
    End Sub
    Public Overrides Sub Write_TypeXML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Typ", "EKG")
    End Sub

    Private Sub CreateNewText()
        Dim TmpText As String = ""
        If m_AbsoluteArrhythmie Then
            If m_Frequenz > 100 Then
                TmpText = "Tachyarrhythmie bei Vorhofflimmmern, mittlere Frequenz " & m_Frequenz.ToString & "/min."
            ElseIf m_Frequenz < 60 Then
                TmpText = "Bradyarrhythmie bei Vorhofflimmmern, mittlere Frequenz " & m_Frequenz.ToString & "/min."
            Else
                TmpText = "Absolute Arrythmie bei Vorhofflimmmern, mittlere Frequenz " & m_Frequenz.ToString & "/min."
            End If
        Else
            Select Case m_LageTyp
                Case EKGLageTypen.Indifferenztyp
                    TmpText = "Indifferenztyp"
                Case EKGLageTypen.Linkstyp
                    TmpText = "Linkstyp"
                Case EKGLageTypen.Rechtstyp
                    TmpText = "Rechtstyp"
                Case EKGLageTypen.Sagittaltyp
                    TmpText = "Sagittaltyp"
                Case EKGLageTypen.Steiltyp
                    TmpText = "Steiltyp"
                Case EKGLageTypen.UeLinkstyp
                    TmpText = "berdrehter Linkstyp"
                Case EKGLageTypen.UeRechtstyp
                    TmpText = "berdrehter Rechtstyp"
            End Select
            If m_Frequenz <> 0 Then
                If m_Frequenz > 100 Then
                    TmpText &= ", Sinustachykardie, "
                ElseIf m_Frequenz < 60 Then
                    TmpText &= ", Sinusbradykardie, "
                Else
                    TmpText &= ", Sinusrhythmus, "
                End If
                TmpText &= "Herzfrequenz " & m_Frequenz.ToString & "/min., "
            Else
                TmpText &= ", Sinusrhythmus, "
            End If
            TmpText &= "normale Erregungsausbreitung und -rckbildung."

        End If

        If Me.Text <> TmpText Then
            Me.Text = TmpText
            Me.ValidateText()
            RaiseEvent TextChanged()
        End If

    End Sub
    Public Overrides Function IsEmpty() As Boolean
        Return False
    End Function
    Public Overrides Function CreateControl() As IEditorControlItem
        Return New EKGEditorItem(Me, False)
    End Function
    Public Overloads Overrides Function CreateControl(ByVal Expanded As Boolean) As IEditorControlItem
        Return New EKGEditorItem(Me, Expanded)
    End Function
End Class
