Imports System.Xml
Public Class EinfachTextEintragsListe
    Inherits TempItemList(Of EinfachTextEintrag)

    Public Overrides Function CreateNewItem() As ChangeListItem
        Return New EinfachTextEintrag(Me)
    End Function

    Public Sub New()
        Me.Add(New EinfachTextEintrag(Me))
    End Sub
    Public Sub New(ByVal xNd As XmlNode)
        For Each Nd As XmlNode In xNd.ChildNodes
            If Nd.Name = "Eintrag" Then
                Me.Add(New EinfachTextEintrag(Me, Nd))
            End If
        Next
        Me.Add(New EinfachTextEintrag(Me))
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each DE As EinfachTextEintrag In Me
            If Not DE.IsEmpty Then
                Writer.WriteStartElement("Eintrag")
                DE.Write_XML(Writer)
                Writer.WriteEndElement()
            End If
        Next
    End Sub

    Public Overrides Sub SortList()
        Dim LastItem As EinfachTextEintrag = Me.Item(Me.Count - 1)
        Me.RemoveAt(Me.Count - 1)
        Me.Sort(New EinfachTextEintragComparer)
        Me.Add(LastItem)
        Me.RaiseChanged("")
    End Sub

    Public Overrides Function CanSort() As Boolean
        Return True
    End Function

    Public Overrides Function GetColorStrings() As System.Collections.Generic.List(Of ColorString)
        Dim Result As New List(Of ColorString)
        For Each Rw As EinfachTextEintrag In Me
            If Not Rw.IsEmpty Then
                Dim Txt As String = Chr(183) & " " & Rw.Text
                Result.Add(New ColorString(Txt))
            End If
        Next
        Return Result
    End Function

    Public Overrides Function HeaderControl() As System.Windows.Forms.Control
        Return New EinfachTextEintragHeader
    End Function
End Class
