Imports System.Xml
Public Class FonFaxListe
    Inherits TempItemList(Of FonFax)

    Public Overrides Function CreateNewItem() As ChangeListItem
        Return New FonFax(Me)
    End Function

    Public Sub New()
        Me.Add(New FonFax(Me))
    End Sub
    Public Sub New(ByVal xNd As XmlNode)
        For Each Nd As XmlNode In xNd.ChildNodes
            If Nd.Name = "Eintrag" Then
                Me.Add(New FonFax(Me, Nd))
            End If
        Next
        Me.Add(New FonFax(Me))
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each DE As FonFax In Me
            If Not DE.IsEmpty Then
                Writer.WriteStartElement("Eintrag")
                DE.Write_XML(Writer)
                Writer.WriteEndElement()
            End If
        Next
    End Sub

    Public Overrides Function HeaderControl() As System.Windows.Forms.Control
        Return New FonFaxHeader
    End Function

    Public Overrides Function CanSort() As Boolean
        Return False
    End Function

    Public Overrides Function GetColorStrings() As System.Collections.Generic.List(Of ColorString)
        Dim Result As New List(Of ColorString)
        For Each Rw As FonFax In Me
            If Not Rw.IsEmpty Then
                Result.Add(New ColorString(Chr(183) & " " & Rw.Bezeichnung & " - " & Rw.Nummer))
            End If
        Next
        Return Result
    End Function
End Class