Imports System.Xml
Public Class MedikamentVerordnung
    Inherits ChangeListItem
    Private m_Medikament As String = ""
    Private m_Frueh As String = "0"
    Private m_Mittag As String = "0"
    Private m_Abend As String = "0"
    Private m_Nacht As String = "0"

    Private m_Hinweise As String = ""

    Private m_Parent As MedikamentVerordnungsListe

    Public Sub New(ByVal Parent As MedikamentVerordnungsListe)
        m_Parent = Parent
    End Sub
    Public Sub New(ByVal Parent As MedikamentVerordnungsListe, ByVal Original As MedikamentVerordnung)
        m_Parent = Parent
        m_Medikament = Original.Medikament
        m_Frueh = Original.Frueh
        m_Mittag = Original.Mittag
        m_Abend = Original.Abend
        m_Nacht = Original.Nacht
        m_Hinweise = Original.Hinweise
    End Sub
    Public Sub New(ByVal Parent As MedikamentVerordnungsListe, ByVal Nd As XmlNode)
        m_Parent = Parent
        m_Medikament = Nd.Attributes("Medikament").Value
        m_Frueh = Nd.Attributes("Frueh").Value
        m_Mittag = Nd.Attributes("Mittag").Value
        m_Abend = Nd.Attributes("Abend").Value
        m_Nacht = Nd.Attributes("Nacht").Value
        m_Hinweise = Nd.Attributes("Hinweise").Value

    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Medikament", m_Medikament)
        Writer.WriteAttributeString("Frueh", m_Frueh)
        Writer.WriteAttributeString("Mittag", m_Mittag)
        Writer.WriteAttributeString("Abend", m_Abend)
        Writer.WriteAttributeString("Nacht", m_Nacht)
        Writer.WriteAttributeString("Hinweise", m_Hinweise)
    End Sub

    Property Medikament() As String
        Get
            Return m_Medikament
        End Get
        Set(ByVal value As String)
            If m_Medikament <> value.Trim Then
                m_Medikament = value.Trim
                m_Parent.RaiseChanged("Medikament")
            End If
        End Set
    End Property
    Property Frueh() As String
        Get
            Return m_Frueh
        End Get
        Set(ByVal value As String)
            If m_Frueh <> value.Trim Then
                m_Frueh = value.Trim
                m_Parent.RaiseChanged("Frueh")
            End If
        End Set
    End Property
    Property Mittag() As String
        Get
            Return m_Mittag
        End Get
        Set(ByVal value As String)
            If m_Mittag <> value.Trim Then
                m_Mittag = value.Trim
                m_Parent.RaiseChanged("Mittag")
            End If
        End Set
    End Property
    Property Abend() As String
        Get
            Return m_Abend
        End Get
        Set(ByVal value As String)
            If m_Abend <> value.Trim Then
                m_Abend = value.Trim
                m_Parent.RaiseChanged("Abend")
            End If
        End Set
    End Property
    Property Nacht() As String
        Get
            Return m_Nacht
        End Get
        Set(ByVal value As String)
            If m_Nacht <> value.Trim Then
                m_Nacht = value.Trim
                m_Parent.RaiseChanged("Nacht")
            End If
        End Set
    End Property
    Property Hinweise() As String
        Get
            Return m_Hinweise
        End Get
        Set(ByVal value As String)
            If m_Hinweise <> value.Trim Then
                m_Hinweise = value.Trim
                m_Parent.RaiseChanged("Hinweise")
            End If
        End Set
    End Property
    ReadOnly Property MedGabeText() As String
        Get
            If IstLeer(m_Frueh) AndAlso IstLeer(m_Mittag) AndAlso IstLeer(m_Abend) AndAlso IstLeer(m_Nacht) Then
                Return ""
            Else
                If IstLeer(m_Nacht) Then
                    Return (m_Frueh & " - " & m_Mittag & " - " & m_Abend)
                Else
                    Return (m_Frueh & " - " & m_Mittag & " - " & m_Abend & " - " & m_Nacht)
                End If
            End If

        End Get
    End Property

    Public Overrides Sub ValidateForNewItem()
        m_Parent.ValidateForNewItem()
    End Sub
    Public Overrides Function CreateControl() As IEditorControlItem
        Return New MedikamentEditorItem(Me)
    End Function

    Public Overrides Function IsEmpty() As Boolean
        If IstLeer(m_Frueh) AndAlso IstLeer(m_Mittag) AndAlso IstLeer(m_Abend) AndAlso IstLeer(m_Nacht) AndAlso IstLeer(m_Hinweise) AndAlso IstLeer(m_Medikament) Then
            Return True
        End If
        Return False
    End Function
    Private Function IstLeer(ByVal Text As String) As Boolean
        If Text = "0" OrElse Text = "" Then
            Return True
        End If
        Return False
    End Function
 
End Class
