Public Class PatientEditor

    Private WithEvents m_Provider As PatientProvider

#Region " Fields "
    Private m_Source As Patient = Nothing
    Private m_Initializing As Boolean = False

    Private m_DiagnoseEditor As EintragsEditor
    Private m_BefundEditor As BefundEditor

    Private m_PatAufgabenEditor As EintragsEditor
    Private m_GenerellAufgabenEditor As EintragsEditor
    Private m_TippEditor As EintragsEditor
    Private m_FreitextEditor As EintragsEditor

    Private m_TopPainter As New HighlightPainter
    Private m_BottomPainter As New HighlightPainter

    Private WithEvents m_UntersuchungsVorschlaege As BefundStichwortListe

    Private WithEvents m_ClickedBox As GroupBox

    Private m_EditControls As New List(Of EintragsEditor)

#End Region

    WriteOnly Property Provider() As PatientProvider
        Set(ByVal value As PatientProvider)
            m_Provider = value

            m_UntersuchungsVorschlaege = DataProvider.BefundStichworte

            Me.TextEintragsListPainterGenerelleAufgaben.Source = DataProvider.Aufgaben
            m_GenerellAufgabenEditor.Source = DataProvider.Aufgaben

            Me.TextEintragsListPainterTipps.Source = DataProvider.Tipps
            m_TippEditor.Source = DataProvider.Tipps
        End Set
    End Property
    Private Sub m_Provider_ActivePatientAdded() Handles m_Provider.ActivePatientAdded
        SetActive(m_Provider.ActiveEditPatient)
    End Sub
    Private Sub m_Provider_ActivePatientGeaendert() Handles m_Provider.ActivePatientGeaendert
        SetActive(m_Provider.ActiveEditPatient)
    End Sub
    Private Sub SetActive(ByVal Pat As Patient)
        If m_Source IsNot Pat Then
            m_Source = Pat
            Patient_Lesen()
        End If
    End Sub
    Private Sub Patient_Lesen()
        m_Initializing = True

        If m_Source Is Nothing Then

            Me.GroupBoxStammdaten.Enabled = False
            Me.GroupBoxDiagnosen.Enabled = False
            Me.GroupBoxAufgaben.Enabled = False
            Me.GroupBoxFreiText.Enabled = False
            Me.GroupBoxGHM.Enabled = False
            Me.GroupBoxAusstehend.Enabled = False
            Me.GroupBoxEdit.Enabled = False
            Me.GroupBoxBefunde.Enabled = False
            Me.StammdatenControl1.Source = Nothing
            Me.StammdatenControl1.Enabled = False

            CheckBoxVorrangig.Checked = False
            CheckBoxVorrangig.Enabled = False
            'Me.TextBoxAE.Text = ""

            Me.AusstehendBefundControl1.SetSource(Nothing, Nothing)
            Me.GesternHeuteMorgenBefundControl1.SetSource(Nothing, Nothing)

            Me.TextEintragsListPainterDiagnosen.Source = Nothing
            Me.BefundTextEintragsListPainter1.Source = Nothing
            Me.TextEintragsListPainterAufgaben.Source = Nothing
            Me.TextEintragsListPainterFreitext.Source = Nothing

            m_DiagnoseEditor.Source = Nothing
            m_BefundEditor.Source = Nothing
            m_PatAufgabenEditor.Source = Nothing
            m_FreitextEditor.Source = Nothing

            m_TopPainter.Color = SystemColors.Control
            m_BottomPainter.Color = SystemColors.Control
        Else

            Dim MinDate As New DateTime(1850, 1, 1)

            Me.GroupBoxStammdaten.Enabled = True
            Me.GroupBoxDiagnosen.Enabled = True
            Me.GroupBoxAufgaben.Enabled = True
            Me.GroupBoxFreiText.Enabled = True
            Me.GroupBoxGHM.Enabled = True
            Me.GroupBoxAusstehend.Enabled = True
            Me.GroupBoxEdit.Enabled = True
            Me.GroupBoxBefunde.Enabled = True


            CheckBoxVorrangig.Checked = m_Source.Vorrangig
            CheckBoxVorrangig.Enabled = True

            Me.StammdatenControl1.Source = m_Source
            Me.StammdatenControl1.Enabled = True
            'Me.TextBoxAE.Text = m_Source.Create_AEString

            Me.AusstehendBefundControl1.SetSource(m_Source, m_UntersuchungsVorschlaege)
            Me.GesternHeuteMorgenBefundControl1.SetSource(m_UntersuchungsVorschlaege, m_Source)

            Me.TextEintragsListPainterDiagnosen.Source = m_Source.XMLPart.Diagnosen
            Me.BefundTextEintragsListPainter1.Source = m_Source.Befunde
            Me.TextEintragsListPainterAufgaben.Source = m_Source.XMLPart.Aufgaben
            Me.TextEintragsListPainterFreitext.Source = m_Source.XMLPart.FreiTexte

            m_DiagnoseEditor.Source = m_Source.XMLPart.Diagnosen
            m_BefundEditor.Source = m_Source.Befunde
            m_PatAufgabenEditor.Source = m_Source.XMLPart.Aufgaben
            m_FreitextEditor.Source = m_Source.XMLPart.FreiTexte


        End If
        m_Initializing = False

    End Sub

    
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_DiagnoseEditor = New EintragsEditor()
        m_BefundEditor = New BefundEditor()
        m_PatAufgabenEditor = New EintragsEditor()
        m_GenerellAufgabenEditor = New EintragsEditor()
        m_TippEditor = New EintragsEditor()
        m_FreitextEditor = New EintragsEditor()

        m_DiagnoseEditor.Init("Diagnosen", Color.Red, Me.GroupBoxDiagnosen)
        m_BefundEditor.Init("Befunde", Color.Blue, Me.GroupBoxBefunde)
        m_PatAufgabenEditor.Init("Patientenbezogene Aufgaben", Color.Yellow, Me.GroupBoxAufgaben)
        m_GenerellAufgabenEditor.Init("Generelle Aufgaben", Color.Orange, Me.GroupBoxGenerelleAufgaben)
        m_TippEditor.Init("Tipps", Color.Violet, Me.GroupBoxTipps)
        m_FreitextEditor.Init("Freitext", Color.Green, Me.GroupBoxFreiText)

        m_EditControls.Add(m_DiagnoseEditor)
        m_EditControls.Add(m_BefundEditor)
        m_EditControls.Add(m_PatAufgabenEditor)
        m_EditControls.Add(m_GenerellAufgabenEditor)
        m_EditControls.Add(m_TippEditor)
        m_EditControls.Add(m_FreitextEditor)

        For Each Ctl As Control In m_EditControls
            Ctl.Visible = False
            Ctl.Dock = DockStyle.Fill
            Me.GroupBoxEdit.Controls.Add(Ctl)
        Next

        Me.Controls.Add(m_TopPainter)
        Me.SplitContainer2.Panel1.Controls.Add(m_BottomPainter)
        m_TopPainter.BringToFront()
        m_BottomPainter.BringToFront()
        Patient_Lesen()
    End Sub

    Private Sub SetEditor(ByVal NewVisibleControl As EintragsEditor)
        m_ClickedBox = NewVisibleControl.Host

        Dim NewCtl As Control = NewVisibleControl
        For Each Ctl As Control In m_EditControls
            If Not Ctl Is NewCtl Then
                Ctl.Visible = False
            End If
        Next
        NewCtl.Visible = True

        Me.GroupBoxEdit.Text = NewVisibleControl.LabelText

     
        m_TopPainter.Location = New Point(m_ClickedBox.Left - 3, GetControlTop(m_ClickedBox))
        m_TopPainter.Size = New Size(2, m_ClickedBox.Height)

        m_BottomPainter.Location = New Point(GroupBoxEdit.Left - 3, GroupBoxEdit.Top)
        m_BottomPainter.Size = New Size(2, GroupBoxEdit.Height)

        m_TopPainter.Color = NewVisibleControl.LabelColor
        m_BottomPainter.Color = NewVisibleControl.LabelColor

    End Sub

    Private Function GetControlTop(ByVal Gesuchtes As Control) As Integer
        Dim GesuchtesControl As Control = Gesuchtes
        Dim TmpTop As Integer = 0
        While GesuchtesControl.Parent IsNot Me
            TmpTop += GesuchtesControl.Top
            GesuchtesControl = GesuchtesControl.Parent
        End While
        TmpTop += GesuchtesControl.Top
        Return TmpTop
    End Function

    Private Sub TextEintragsListPainterDiagnosen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextEintragsListPainterDiagnosen.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(m_DiagnoseEditor)
    End Sub
    Private Sub BefundTextEintragsListPainter1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BefundTextEintragsListPainter1.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(m_BefundEditor)

    End Sub
    Private Sub TextEintragsListPainterAufgaben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextEintragsListPainterAufgaben.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(m_PatAufgabenEditor)

    End Sub
    Private Sub TextEintragsListPainterGenerelleAufgaben_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextEintragsListPainterGenerelleAufgaben.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(Me.m_GenerellAufgabenEditor)
    End Sub
    Private Sub TextEintragsListPainterTipps_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextEintragsListPainterTipps.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(Me.m_TippEditor)
    End Sub
    Private Sub TextEintragsListPainterFreitext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextEintragsListPainterFreitext.Click
        If m_Source Is Nothing Then Exit Sub
        SetEditor(Me.m_FreitextEditor)
    End Sub

    Private Sub NavigateToBefund(ByVal Befund As PatientBefund) Handles AusstehendBefundControl1.NavigateToBefund, GesternHeuteMorgenBefundControl1.NavigateToBefund
        If m_Source Is Nothing Then Exit Sub
        SetEditor(Me.m_BefundEditor)
        m_BefundEditor.SetSelectedControl(Befund.Befund)
    End Sub

    Private Sub StammdatenControl1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StammdatenControl1.Click
        DataProvider.PatientProvider.Stammdaten_Bearbeiten()
    End Sub

    Private Sub PatientEditor_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If m_ClickedBox IsNot Nothing Then
            m_TopPainter.Location = New Point(m_ClickedBox.Left - 3, GetControlTop(m_ClickedBox))
            m_TopPainter.Size = New Size(2, m_ClickedBox.Height)
        End If

    End Sub

    Private Sub m_ClickedBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_ClickedBox.Resize
        If m_ClickedBox IsNot Nothing Then
            m_TopPainter.Location = New Point(m_ClickedBox.Left - 3, GetControlTop(m_ClickedBox))
            m_TopPainter.Size = New Size(2, m_ClickedBox.Height)
        End If
    End Sub

    Private Sub CheckBoxVorrangig_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxVorrangig.CheckedChanged
        If m_Source Is Nothing Then Exit Sub
        If m_Initializing Then Exit Sub
        m_Source.Vorrangig = CheckBoxVorrangig.Checked
    End Sub
End Class
