Public Class PatientSuchItem
    Inherits PatientSelectorItem

    Private m_Label As PatientLabel
    Private m_Source As PatientSuchSelectorSource
    ReadOnly Property Label() As PatientLabel
        Get
            Return m_Label
        End Get
    End Property
    Public Sub New(ByVal Label As PatientLabel, ByVal Source As PatientSuchSelectorSource)
        m_Label = Label
        m_Source = Source
    End Sub

    Public Overrides ReadOnly Property CanMoveUp() As Boolean
        Get
            Return False
        End Get
    End Property
    Public Overrides ReadOnly Property CanMoveDown() As Boolean
        Get
            Return False
        End Get
    End Property


    Public Overrides ReadOnly Property CanDelete() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property CanEntlassen() As Boolean
        Get
            Dim MinDatum As New Date(1860, 1, 1)
            If m_Label.Entlassungsdatum < MinDatum Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property

    Public Overrides ReadOnly Property CanSelect() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Sub MoveDown()

    End Sub

    Public Overrides Sub MoveUp()

    End Sub


    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As Font)

        g.DrawImage(m_Label.ThumbNail, 4, Me.Top - TopDistance)

        Dim TextRect As New RectangleF(20, Me.Top - TopDistance + 1, Width - 5 - 18, Me.Height)
        g.DrawString(m_Label.KurzText, Ft, Brushes.Black, TextRect)

    End Sub
    Public Overrides Sub DrawSelected(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As System.Drawing.Font)
        g.DrawImage(m_Label.ThumbNail, 4, Me.Top - TopDistance)

        Dim SelRect As New RectangleF(20, Me.Top - TopDistance, Width - 5 - 17, SelectionHeight)
        Dim TextRect As New RectangleF(20, Me.Top - TopDistance + 1, Width - 5 - 18, Me.Height)

        g.FillRectangle(SystemBrushes.Highlight, SelRect)
        g.DrawString(m_Label.KurzText, Ft, Brushes.White, TextRect)
    End Sub


    Public Overrides Function GetVisibilityTop() As Integer
        Return Me.Top
    End Function

    Public Overrides Function GetVisibilityHeight() As Integer
        Return Me.Height
    End Function


    Public Overrides ReadOnly Property SelectionHeight() As Integer
        Get
            Return Me.Height + 1
        End Get
    End Property
End Class
