Public Class StationsBettItem
    Inherits PatientSelectorItem


    Private m_Patienten As New List(Of StationsPatientItem)
    Private m_Zimmer As StationsZimmerItem
    Private m_BettNr As Integer
    Public Sub New(ByVal Zimmer As StationsZimmerItem, ByVal BettNr As Integer)
        m_Zimmer = Zimmer
        m_BettNr = BettNr
    End Sub
    ReadOnly Property BettNr() As Integer
        Get
            Return m_BettNr
        End Get
    End Property
    ReadOnly Property Zimmer() As StationsZimmerItem
        Get
            Return m_Zimmer
        End Get
    End Property
    ReadOnly Property Patienten() As List(Of StationsPatientItem)
        Get
            Return m_Patienten
        End Get
    End Property

    Public Overrides ReadOnly Property CanDelete() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanEntlassen() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveDown() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveUp() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanSelect() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Sub MoveDown()

    End Sub

    Public Overrides Sub MoveUp()

    End Sub
    Public Sub ReOrderPatienten()
        Dim Zaehler As Integer = 0
        For Each Pat As StationsPatientItem In m_Patienten
            Pat.Label.Bettnummer = m_BettNr
            Pat.Label.BettSortnummer = Zaehler
            Zaehler += 1
        Next

        If Not m_Zimmer Is m_Zimmer.Station.OhneBettZimmer Then
            Dim ZimmerNr As String = m_Zimmer.Text
            For Each Pat As StationsPatientItem In m_Patienten
                Pat.Label.Zimmernummer = ZimmerNr
            Next
        End If

    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As Font)
        g.DrawImage(My.Resources.Bett, 4, Me.Top - TopDistance + 2)
    End Sub
    Public Overrides Sub DrawSelected(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As System.Drawing.Font)
        Dim SelRect As New RectangleF(36, Me.Top - TopDistance, Width - 5 - 33, SelectionHeight)

        Dim ForeRect As New Rectangle(2, Me.Top - TopDistance, 36, Me.Height + 1)

        g.FillRectangle(SystemBrushes.Highlight, SelRect)
        g.DrawRectangle(SystemPens.Highlight, ForeRect)
        g.DrawImage(My.Resources.Bett, 4, Me.Top - TopDistance + 2)

    End Sub

    Public Overrides Function GetVisibilityTop() As Integer
        Return m_Zimmer.Top
    End Function

    Public Overrides Function GetVisibilityHeight() As Integer
        Return m_Zimmer.Height + m_Zimmer.Items.Height
    End Function


    Public Overrides ReadOnly Property SelectionHeight() As Integer
        Get
            Return Me.Height + 2
        End Get
    End Property
End Class
