Public Class StationsPatientItem
    Inherits PatientSelectorItem


    Private m_Label As PatientLabel
    Private m_Bett As StationsBettItem

    ReadOnly Property Bett() As StationsBettItem
        Get
            Return m_Bett
        End Get
    End Property
    Public Sub New(ByVal Label As PatientLabel, ByVal Bett As StationsBettItem)
        m_Label = Label
        m_Bett = Bett
    End Sub
    ReadOnly Property Label() As PatientLabel
        Get
            Return m_Label
        End Get
    End Property

    Public Overrides ReadOnly Property CanDelete() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides ReadOnly Property CanEntlassen() As Boolean
        Get
            Dim MinDatum As New Date(1860, 1, 1)
            If m_Label.Entlassungsdatum < MinDatum Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveDown() As Boolean
        Get
            If m_Bett.Patienten.IndexOf(Me) = m_Bett.Patienten.Count - 1 Then
                Dim Zi As StationsZimmerItem = m_Bett.Zimmer
                If Zi.Betten.IndexOf(m_Bett) = Zi.Betten.Count - 1 Then
                    Dim Stat As PatientStationsSelectorSource = Zi.Station
                    If Stat.Zimmer.IndexOf(Zi) = Stat.Zimmer.Count - 1 Then
                        Return False
                    Else
                        Return True
                    End If
                Else
                    Return True
                End If
            Else
                Return True
            End If
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveUp() As Boolean
        Get
            If m_Bett.Patienten.IndexOf(Me) = 0 Then
                Dim Zi As StationsZimmerItem = m_Bett.Zimmer
                If Zi.Betten.IndexOf(m_Bett) = 0 Then
                    Dim Stat As PatientStationsSelectorSource = Zi.Station
                    If Stat.Zimmer.IndexOf(Zi) = 0 Then
                        Return False
                    Else
                        Return True
                    End If
                Else
                    Return True
                End If
            Else
                Return True
            End If
        End Get
    End Property

    Public Overrides ReadOnly Property CanSelect() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Sub MoveDown()
        Dim Zi As StationsZimmerItem = m_Bett.Zimmer
        If Zi.Betten.IndexOf(m_Bett) = Zi.Betten.Count - 1 Then
            Dim Stat As PatientStationsSelectorSource = Zi.Station
            If Stat.Zimmer.IndexOf(Zi) = Stat.Zimmer.Count - 1 Then
                If m_Bett.Patienten.IndexOf(Me) < m_Bett.Patienten.Count - 1 Then
                    Dim MyIndex As Integer = m_Bett.Patienten.IndexOf(Me)
                    m_Bett.Patienten.Remove(Me)
                    m_Bett.Patienten.Insert(MyIndex + 1, Me)
                    m_Bett.ReOrderPatienten()
                    m_Bett.Zimmer.Station.RaiseOrderChanged()
                End If
            Else
                Dim MyIndex As Integer = Stat.Zimmer.IndexOf(Zi)
                m_Bett.Patienten.Remove(Me)
                Stat.Zimmer(MyIndex + 1).Betten(0).Patienten.Insert(0, Me)
                m_Bett = Stat.Zimmer(MyIndex + 1).Betten(0)
                m_Bett.ReOrderPatienten()
                m_Bett.Zimmer.Station.RaiseOrderChanged()
            End If
        Else
            Dim MyIndex As Integer = Zi.Betten.IndexOf(m_Bett)
            m_Bett.Patienten.Remove(Me)
            Zi.Betten(MyIndex + 1).Patienten.Insert(0, Me)
            m_Bett = Zi.Betten(MyIndex + 1)
            m_Bett.ReOrderPatienten()
            m_Bett.Zimmer.Station.RaiseOrderChanged()
        End If


    End Sub

    Public Overrides Sub MoveUp()
        Dim MustRaiseChanged As Boolean = False

        Dim Zi As StationsZimmerItem = m_Bett.Zimmer
        If Zi.Betten.IndexOf(m_Bett) = 0 Then
            Dim Stat As PatientStationsSelectorSource = Zi.Station
            If Stat.Zimmer.IndexOf(Zi) = 0 Then
                If m_Bett.Patienten.IndexOf(Me) > 0 Then
                    Dim MyIndex As Integer = m_Bett.Patienten.IndexOf(Me)
                    m_Bett.Patienten.Remove(Me)
                    m_Bett.Patienten.Insert(MyIndex - 1, Me)
                    MustRaiseChanged = True
                End If
            Else
                Dim MyIndex As Integer = Stat.Zimmer.IndexOf(Zi)
                m_Bett.Patienten.Remove(Me)
                Dim NewBett As StationsBettItem = Stat.Zimmer(MyIndex - 1).Betten(Stat.Zimmer(MyIndex - 1).Betten.Count - 1)
                NewBett.Patienten.Insert(0, Me)
                m_Bett = NewBett
                MustRaiseChanged = True
            End If
        Else
            Dim MyIndex As Integer = Zi.Betten.IndexOf(m_Bett)
            m_Bett.Patienten.Remove(Me)
            Zi.Betten(MyIndex - 1).Patienten.Insert(0, Me)
            m_Bett = Zi.Betten(MyIndex - 1)
            MustRaiseChanged = True
        End If


        If MustRaiseChanged Then
            m_Bett.Zimmer.Station.TryDeleteOhneBettZimmer()
            m_Bett.ReOrderPatienten()
            m_Bett.Zimmer.Station.RaiseOrderChanged()
        End If
    End Sub

    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As Font)

        g.DrawImage(m_Label.ThumbNail, 20, Me.Top - TopDistance + 2)

        Dim TextRect As New RectangleF(36, Me.Top - TopDistance + 1, Width - 5 - 34, Me.Height)
        g.DrawString(m_Label.KurzText, Ft, Brushes.Black, TextRect)

        If m_Bett.Patienten(0) Is Me Then
            g.DrawImage(My.Resources.Bett, 4, Me.Top - TopDistance + 2)
        End If

    End Sub
    Public Overrides Sub DrawSelected(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As System.Drawing.Font)
        g.DrawImage(m_Label.ThumbNail, 20, Me.Top - TopDistance + 2)

        Dim SelRect As New RectangleF(36, Me.Top - TopDistance, Width - 5 - 33, SelectionHeight)
        Dim TextRect As New RectangleF(36, Me.Top - TopDistance + 1, Width - 5 - 34, Me.Height)
        Dim ForeRect As New Rectangle(2, Me.Top - TopDistance, 36, Me.Height + 1)

        g.FillRectangle(SystemBrushes.Highlight, SelRect)
        g.DrawString(m_Label.KurzText, Ft, Brushes.White, TextRect)
        g.DrawRectangle(SystemPens.Highlight, ForeRect)

        If m_Bett.Patienten(0) Is Me Then
            g.DrawImage(My.Resources.Bett, 4, Me.Top - TopDistance + 2)
        End If
    End Sub

    Public Overrides Function GetVisibilityTop() As Integer
        Return m_Bett.Zimmer.Top
    End Function

    Public Overrides Function GetVisibilityHeight() As Integer
        Return m_Bett.Zimmer.Height + m_Bett.Zimmer.Items.Height
    End Function


    Public Overrides ReadOnly Property SelectionHeight() As Integer
        Get
            Return Me.Height + 2
        End Get
    End Property
End Class
