Imports System.Drawing.Drawing2D
Public Class StationsZimmerItem
    Inherits PatientSelectorItem

    Private Shared TopBrush As Brush
    Private Shared TopPen As Pen

    Shared Sub New()
        TopBrush = New SolidBrush(Color.FromArgb(51, 166, 49))
        TopPen = New Pen(Color.FromArgb(26, 135, 26))
    End Sub

    Private m_Betten As New List(Of StationsBettItem)
    Private m_Station As PatientStationsSelectorSource
    Private m_Text As String = ""

    Private m_Items As New PatientSelectorItemList
  
    ReadOnly Property Items() As PatientSelectorItemList
        Get
            Return m_Items
        End Get
    End Property

    ReadOnly Property Text() As String
        Get
            Return m_Text
        End Get
    End Property
    Public Sub New(ByVal Station As PatientStationsSelectorSource, ByVal Text As String)
        m_Station = Station
        m_Text = Text
    End Sub
    ReadOnly Property Station() As PatientStationsSelectorSource
        Get
            Return m_Station
        End Get
    End Property
    ReadOnly Property Betten() As List(Of StationsBettItem)
        Get
            Return m_Betten
        End Get
    End Property


    Public Overrides ReadOnly Property CanDelete() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanEntlassen() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveDown() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanMoveUp() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property CanSelect() As Boolean
        Get
            Return True
        End Get
    End Property

    Public Overrides Sub MoveDown()

    End Sub

    Public Overrides Sub MoveUp()

    End Sub
    
    Public Function GetMouseDownItem(ByVal MouseVirtualTop As Integer) As PatientSelectorItem
        Dim InternTop As Integer = MouseVirtualTop - Me.Top - Me.Height
        If InternTop < 0 Then
            Return Me
        Else
            For Each Item As PatientSelectorItem In m_Items
                If Item.Top < InternTop AndAlso Item.Top + Item.Height > InternTop Then
                    Return Item
                End If
            Next
        End If
        Return Nothing
    End Function


    Public Overrides Sub Draw(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As Font)

        Dim TopRect As New RectangleF(2, Me.Top - TopDistance, Width - 5, Me.Height)

        g.FillRectangle(TopBrush, TopRect)
        g.DrawRectangle(TopPen, TopRect.X, TopRect.Y, TopRect.Width, TopRect.Height)

        TopRect.Offset(0.0F, 1.0F)
        g.DrawString(m_Text, Ft, Brushes.White, TopRect)

    End Sub
    Public Overrides Sub DrawSelected(ByVal g As System.Drawing.Graphics, ByVal Width As Integer, ByVal TopDistance As Integer, ByVal Ft As System.Drawing.Font)
        Dim TopRect As New RectangleF(2, Me.Top - TopDistance, Width - 5, Me.Height)

        g.FillRectangle(SystemBrushes.Highlight, TopRect)
        g.DrawRectangle(SystemPens.ControlDarkDark, TopRect.X, TopRect.Y, TopRect.Width, TopRect.Height)
        TopRect.Offset(0.0F, 1.0F)
        g.DrawString(m_Text, Ft, Brushes.White, TopRect)

    End Sub
    Public Overrides Function GetVisibilityTop() As Integer
        Return Me.Top
    End Function

    Public Overrides Function GetVisibilityHeight() As Integer
        Return Me.Height + m_Items.Height
    End Function


    Public Overrides ReadOnly Property SelectionHeight() As Integer
        Get
            Return Me.Height
        End Get
    End Property
End Class
