Public Class PatientNormalSelectorSource
    Inherits PatientSelectorSource


    Private WithEvents m_Provider As PatientProvider
    Private m_Modus As PatientAnzeigeModi
    Private m_Labels As New List(Of PatientLabel)

    Public Sub New(ByVal Modus As PatientAnzeigeModi, ByVal SelectedLabel As PatientLabel)
        m_Provider = DataProvider.PatientProvider
        m_Modus = Modus
        FillWithItems()
        SetSelectedWithoutEvents(SelectedLabel)
    End Sub

    Private Sub FillWithItems()
        m_Provider.Sort(New PatientLabelComparer)
        m_Provider.Geaendert = True

        Me.Items.Add(New DistanceItem(3))
        Dim MinDatum As New Date(1860, 1, 1)
        Select Case m_Modus
            Case PatientAnzeigeModi.ABisZ
                For Each Lbl As PatientLabel In m_Provider
                    If Lbl.Entlassungsdatum < MinDatum Then
                        Me.Items.Add(New SortedPatientSelectorItem(Lbl, Me))
                        m_Labels.Add(Lbl)
                    End If
                Next
            Case PatientAnzeigeModi.Entlassene
                For Each Lbl As PatientLabel In m_Provider
                    If Lbl.Entlassungsdatum > MinDatum Then
                        Me.Items.Add(New SortedPatientSelectorItem(Lbl, Me))
                        m_Labels.Add(Lbl)
                    End If
                Next
            Case PatientAnzeigeModi.Alle
                For Each Lbl As PatientLabel In m_Provider
                    Me.Items.Add(New SortedPatientSelectorItem(Lbl, Me))
                    m_Labels.Add(Lbl)
                Next
        End Select
    End Sub





    'Public Overrides Function ContainsLabel(ByVal Lbl As PatientLabel) As Boolean
    '    Return m_Labels.Contains(Lbl)
    'End Function

    Public Overrides Function SetSelectedWithoutEvents(ByVal Lbl As PatientLabel) As Boolean
        If m_Labels.Contains(Lbl) Then
            SetInternSelected(Me.Items(m_Labels.IndexOf(Lbl) + 1))
            Return True
        End If
        Return False
    End Function

    Public Overrides ReadOnly Property AllLabels() As PatientLabelGroupCollection
        Get
            Dim Result As New PatientLabelGroupCollection("")
            Dim Grp As New PatientLabelGroup("")
            Result.Add(Grp)
            Grp.AddRange(m_Labels.ToArray)
            Return Result
        End Get
    End Property
End Class
