Public MustInherit Class PatientSelectorSource
    Public Event SelectedItem_Changed()
    Public Event Order_Changed()

    Private m_SelectedItem As PatientSelectorItem
    Private m_Items As New PatientSelectorItemList

    MustOverride ReadOnly Property AllLabels() As PatientLabelGroupCollection

    ReadOnly Property Items() As PatientSelectorItemList
        Get
            Return m_Items
        End Get
    End Property
    Property SelectedItem() As PatientSelectorItem
        Get
            Return m_SelectedItem
        End Get
        Set(ByVal value As PatientSelectorItem)
            If m_SelectedItem IsNot value Then
                m_SelectedItem = value
                RaiseEvent SelectedItem_Changed()
            End If
        End Set
    End Property
    Public Sub SetInternSelected(ByVal value As PatientSelectorItem)
        m_SelectedItem = value
    End Sub

    ReadOnly Property FullHeight() As Integer
        Get
            Return m_Items.Height
        End Get
    End Property

    Public Overridable Sub RaiseOrderChanged()
        RaiseEvent Order_Changed()
    End Sub

    'Public Overridable Sub Paint(ByVal g As System.Drawing.Graphics, ByVal Top As Integer, ByVal ControllHeight As Integer, ByVal Width As Integer, ByVal Ft As Font)

    '    Dim Start As Integer = 0
    '    Dim Ende As Integer = m_Items.Count - 1

    '    For I As Integer = 0 To m_Items.Count - 1
    '        If m_Items(I).Top + m_Items(I).Height > Top Then
    '            Start = I
    '            Exit For
    '        End If
    '    Next
    '    For I As Integer = m_Items.Count - 1 To 0 Step -1
    '        If m_Items(I).Top < Top + ControllHeight Then
    '            Ende = I
    '            Exit For
    '        End If
    '    Next


    '    For I As Integer = Start To Ende
    '        m_Items(I).Draw(g, Width, Top, Ft)
    '    Next

    'End Sub

    Public Function GePaintItems(ByVal Top As Integer, ByVal ControllHeight As Integer) As List(Of PatientSelectorItem)
        Dim Start As Integer = 0
        Dim Ende As Integer = m_Items.Count - 1
        'Dim Result As New List(Of PatientSelectorItem)

        For I As Integer = 0 To m_Items.Count - 1
            If m_Items(I).Top + m_Items(I).Height > Top Then
                Start = I
                Exit For
            End If
        Next
        For I As Integer = m_Items.Count - 1 To 0 Step -1
            If m_Items(I).Top < Top + ControllHeight Then
                Ende = I
                Exit For
            End If
        Next

        Return m_Items.GetRange(Start, Ende - Start + 1)

    End Function


    Public Sub MouseDown(ByVal MouseTop As Integer)
        Dim FoundItem As PatientSelectorItem = Nothing
        For Each Itm As PatientSelectorItem In Me.Items
            If Itm.CanSelect Then
                If Itm.Top <= MouseTop AndAlso Itm.Top + Itm.Height >= MouseTop Then
                    FoundItem = Itm
                    Exit For
                End If
            End If
        Next

        If FoundItem IsNot Nothing Then
            Me.SelectedItem = FoundItem
        End If
    End Sub
    'MustOverride Function ContainsLabel(ByVal Lbl As PatientLabel) As Boolean
    MustOverride Function SetSelectedWithoutEvents(ByVal Lbl As PatientLabel) As Boolean
End Class
