Public Class PatientSuchSelectorSource
    Inherits PatientSelectorSource
    Private WithEvents m_Provider As PatientProvider
    Private m_Labels As New List(Of PatientLabel)
    Public Sub New(ByVal SelectedLabel As PatientLabel)

        m_Provider = DataProvider.PatientProvider
        FillWithItems()
        SetSelectedWithoutEvents(SelectedLabel)

    End Sub
    Private Sub FillWithItems()
        m_Provider.Sort(New PatientLabelComparer)
        m_Provider.Geaendert = True

        Me.Items.Add(New DistanceItem(3))
        Dim MinDatum As New Date(1860, 1, 1)

        Dim Einstellungen As SuchEinstellungen = DataProvider.SuchEinstellungen
        Dim TmpLabels As New List(Of PatientLabel)

        Select Case Einstellungen.ZeitBereich
            Case SuchEinstellungsZeitbereiche.Aktuelle
                For Each Lbl As PatientLabel In m_Provider
                    If Lbl.Entlassungsdatum < MinDatum Then
                        TmpLabels.Add(Lbl)
                    End If
                Next
            Case SuchEinstellungsZeitbereiche.Alle
                For Each Lbl As PatientLabel In m_Provider
                    TmpLabels.Add(Lbl)
                Next
            Case SuchEinstellungsZeitbereiche.Entlassene
                For Each Lbl As PatientLabel In m_Provider
                    If Lbl.Entlassungsdatum > MinDatum Then
                        TmpLabels.Add(Lbl)
                    End If
                Next
            Case SuchEinstellungsZeitbereiche.VierzehnTage
                Dim VDatum As Date = Date.Today.AddDays(-14)
                For Each Lbl As PatientLabel In m_Provider
                    If Lbl.Entlassungsdatum < MinDatum OrElse Lbl.Entlassungsdatum > VDatum Then
                        TmpLabels.Add(Lbl)
                    End If
                Next
        End Select

        Select Case Einstellungen.BefundAuswahl
            Case SuchEinstellungsBefundAuswahlen.Befunde
                For Each Lbl As PatientLabel In TmpLabels
                    Dim Pat As Patient = m_Provider.GetTempPatient(Lbl)
                    For Each Bef As BefundTextEintrag In Pat.XMLPart.Befunde
                        If Einstellungen.SelectedBefunde.Contains(Bef.Kategorie) AndAlso Bef.Text <> "" Then
                            Me.Items.Add(New PatientSuchItem(Lbl, Me))
                            m_Labels.Add(Lbl)
                            Exit For
                        End If
                    Next
                Next
            Case SuchEinstellungsBefundAuswahlen.FehlendUndLeer
                For Each Lbl As PatientLabel In TmpLabels
                    Dim Pat As Patient = m_Provider.GetTempPatient(Lbl)

                    Dim KategorieNichtGefunden As Boolean = False
                    Dim KategorieTextFehlt As Boolean = False

                    'SelectedBefunde enthlt die Befunde nach denen gesucht werden soll

                    'Fr alle Befunde in SelectedBefunde
                    'Wenn kein Befund beim Patienten existiert, der als Kategorie 
                    'den gesuchten String enthlt
                    'oder dieser Befund leeren Text enthlt
                    'wird der Patient zur Ergebnis-Liste hinzugefgt

                    'Suche, ob die Kategorie berhaupt vorhanden ist
                    For Each txt As String In Einstellungen.SelectedBefunde
                        KategorieNichtGefunden = True
                        For Each Bef As BefundTextEintrag In Pat.Befunde
                            If Bef.Kategorie = txt Then
                                KategorieNichtGefunden = False
                                Exit For
                            End If
                        Next
                        If KategorieNichtGefunden Then
                            Exit For
                        End If
                    Next


                    If Not KategorieNichtGefunden Then
                        'Alle Kategorien sind auf jeden Fall vorhanden
                        'Jetzt berprfen, ob fr eine dieser Kategorien leerer Text vorhanden ist
                        For Each Bef As BefundTextEintrag In Pat.Befunde
                            If Bef.Text = "" AndAlso Einstellungen.SelectedBefunde.Contains(Bef.Kategorie) Then
                                KategorieTextFehlt = True
                                Exit For
                            End If
                            If KategorieTextFehlt Then Exit For
                        Next
                    End If



                    'For Each txt As String In Einstellungen.SelectedBefunde
                    '    KategorieNichtGefunden = True
                    '    For Each Bef As BefundTextEintrag In Pat.Befunde
                    '        If Bef.Kategorie = txt AndAlso Bef.Text <> "" Then
                    '            KategorieNichtGefunden = False
                    '        End If
                    '    Next
                    '    If KategorieNichtGefunden Then
                    '        Exit For
                    '    End If
                    'Next





                    'For Each txt As String In Einstellungen.SelectedBefunde
                    '    KategorieNichtGefunden = True
                    '    For Each Bef As BefundTextEintrag In Pat.Befunde
                    '        If Bef.Kategorie = txt Then
                    '            KategorieNichtGefunden = False
                    '            If Bef.Text = "" Then
                    '                KategorieTextFehlt = True
                    '                Exit For
                    '            End If
                    '        End If
                    '    Next
                    '    If KategorieNichtGefunden OrElse KategorieTextFehlt Then
                    '        Exit For
                    '    End If
                    'Next


                    If KategorieNichtGefunden OrElse KategorieTextFehlt Then
                        Me.Items.Add(New PatientSuchItem(Lbl, Me))
                        m_Labels.Add(Lbl)
                    End If
                Next
            Case SuchEinstellungsBefundAuswahlen.Leer
                For Each Lbl As PatientLabel In TmpLabels
                    Dim Pat As Patient = m_Provider.GetTempPatient(Lbl)

                    Dim KategorieTextFehlt As Boolean = False

                    For Each txt As String In Einstellungen.SelectedBefunde
                        For Each Bef As BefundTextEintrag In Pat.XMLPart.Befunde
                            If Bef.Kategorie = txt Then
                                If Bef.Text = "" Then
                                    KategorieTextFehlt = True
                                    Exit For
                                End If
                            End If
                        Next
                        If KategorieTextFehlt Then
                            Exit For
                        End If
                    Next
                    If KategorieTextFehlt Then
                        Me.Items.Add(New PatientSuchItem(Lbl, Me))
                        m_Labels.Add(Lbl)
                    End If
                Next
        End Select

    End Sub
    Public Overrides Function SetSelectedWithoutEvents(ByVal Lbl As PatientLabel) As Boolean
        If m_Labels.Contains(Lbl) Then
            SetInternSelected(Me.Items(m_Labels.IndexOf(Lbl) + 1))
            Return True
        End If
        Return False
    End Function
    Public Overrides ReadOnly Property AllLabels() As PatientLabelGroupCollection
        Get
            Dim Result As New PatientLabelGroupCollection("")
            Dim Grp As New PatientLabelGroup("")
            Result.Add(Grp)
            Grp.AddRange(m_Labels.ToArray)
            Return Result
        End Get
    End Property
End Class
