Imports System.Xml
Public Class SuchEinstellungen
    Private m_SelectedBefunde As New List(Of String)
    Private m_ZeitBereich As SuchEinstellungsZeitbereiche = SuchEinstellungsZeitbereiche.Aktuelle
    Private m_BefundAuswahl As SuchEinstellungsBefundAuswahlen = SuchEinstellungsBefundAuswahlen.FehlendUndLeer

    ReadOnly Property SelectedBefunde() As List(Of String)
        Get
            Return m_SelectedBefunde
        End Get
    End Property
    Property ZeitBereich() As SuchEinstellungsZeitbereiche
        Get
            Return m_ZeitBereich
        End Get
        Set(ByVal value As SuchEinstellungsZeitbereiche)
            m_ZeitBereich = value
        End Set
    End Property
    Property BefundAuswahl() As SuchEinstellungsBefundAuswahlen
        Get
            Return m_BefundAuswahl
        End Get
        Set(ByVal value As SuchEinstellungsBefundAuswahlen)
            m_BefundAuswahl = value
        End Set
    End Property
    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As Xmlnode)
        m_ZeitBereich = CType(CInt(Nd.Attributes("ZeitBereich").Value), SuchEinstellungsZeitbereiche)
        m_BefundAuswahl = CType(CInt(Nd.Attributes("BefundAuswahl").Value), SuchEinstellungsBefundAuswahlen)
        Dim Befunde() As String = Nd.Attributes("Befunde").Value.Split("|")
        For Each txt As String In Befunde
            m_SelectedBefunde.Add(txt)
        Next
    End Sub
    Public Sub New(ByVal Einstellungen As SuchEinstellungen)
        m_ZeitBereich = Einstellungen.ZeitBereich
        m_BefundAuswahl = Einstellungen.BefundAuswahl
        For Each txt As String In Einstellungen.SelectedBefunde
            m_SelectedBefunde.Add(txt)
        Next
    End Sub
    Public Sub Write_Xml(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("ZeitBereich", CInt(m_ZeitBereich).ToString)
        Writer.WriteAttributeString("BefundAuswahl", CInt(m_BefundAuswahl).ToString)
        Dim Befunde() As String = m_SelectedBefunde.ToArray
        Writer.WriteAttributeString("Befunde", Join(Befunde, "|"))
    End Sub
    Public Sub ReadValues(ByVal Original As SuchEinstellungen)
        m_ZeitBereich = Original.ZeitBereich
        m_BefundAuswahl = Original.BefundAuswahl
        m_SelectedBefunde.Clear()
        For Each txt As String In Original.SelectedBefunde
            m_SelectedBefunde.Add(txt)
        Next
    End Sub

    Public Function Edit() As Boolean
        Dim Clone As SuchEinstellungen = New SuchEinstellungen(Me)

        Dim frm As New frm_SpezialSuche(Clone)
        If frm.ShowDialog = DialogResult.OK Then
            Me.ReadValues(Clone)
            Return True
        End If
        Return False
    End Function
End Class
