Public Class Adress_Editor

    Private WithEvents m_Adresse As IAdresse
    Private WithEvents m_Titel As TitelListe
    Private m_Initializing As Boolean = False

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie m_Initializingen nach dem InitializeComponent()-Aufruf hinzu.
        m_Titel = DataProvider.Titel
        For Each TI As Titel In m_Titel
            TitelComboBox.Items.Add(TI)
        Next
    End Sub
    WriteOnly Property Adresse() As IAdresse
        Set(ByVal value As IAdresse)
            m_Adresse = value
            ReadValues()
        End Set
    End Property

    Private Sub ReadValues()
        m_Initializing = True

        If m_Adresse IsNot Nothing Then
            Me.FirmaTextBox.Text = m_Adresse.Firma
            Me.Firma1TextBox.Text = m_Adresse.Firma1
            Me.StellungTextBox.Text = m_Adresse.Stellung
            Me.FirmavoranCheckBox.Checked = m_Adresse.FirmaVoran
            Select Case m_Adresse.Geschlecht
                Case Geschlechter.maennlich
                    Me.RadioButtonMaennl.Checked = True
                Case Geschlechter.weiblich
                    Me.RadioButtonWeibl.Checked = True
                Case Geschlechter.unpersoenlich
                    Me.RadioButtonUnpers.Checked = True
            End Select
            Me.TitelComboBox.Text = m_Adresse.Titel
            Me.NachnameTextBox.Text = m_Adresse.Nachname
            Me.VornameTextBox.Text = m_Adresse.Vorname
            Me.OrtTextBox.Text = m_Adresse.Ort
            Me.PlzTextBox.Text = m_Adresse.PLZ
            Me.StrasseTextBox.Text = m_Adresse.Strasse
            Dim MinDatum As New Date(1860, 1, 1)
            If m_Adresse.Geburtsdatum < MinDatum Then
                Me.GeburtstagValidatedDateTextBox.Text = ""
            Else
                Me.GeburtstagValidatedDateTextBox.Text = m_Adresse.Geburtsdatum.ToShortDateString
            End If
            Me.EintragsEditor1.Source = m_Adresse.FonFax
            BriefanredeCombo_Fllen()

            Me.RadioButtonUnpers.Enabled = True
            Me.Panel1.Enabled = True
            Me.BriefanredeComboBox.Enabled = True
            Me.TextBoxAdressansicht.Text = m_Adresse.AdressAnsicht
            Me.Enabled = True
        Else
            Me.FirmaTextBox.Text = ""
            Me.Firma1TextBox.Text = ""
            Me.StellungTextBox.Text = ""
            Me.FirmavoranCheckBox.Checked = False
            Me.RadioButtonMaennl.Checked = True
            Me.TitelComboBox.Text = ""
            Me.NachnameTextBox.Text = ""
            Me.VornameTextBox.Text = ""
            Me.OrtTextBox.Text = ""
            Me.PlzTextBox.Text = ""
            Me.StrasseTextBox.Text = ""
            Me.BriefanredeComboBox.Text = ""
            Me.GeburtstagValidatedDateTextBox.Text = ""
            Me.EintragsEditor1.Source = Nothing
            Me.TextBoxAdressansicht.Text = ""
            Me.Enabled = False
        End If

        m_Initializing = False
    End Sub
    Private Sub BriefanredeCombo_Fllen()
        Me.BriefanredeComboBox.Items.Clear()
        Me.BriefanredeComboBox.Items.AddRange(m_Adresse.Anredevorschlaege.Anreden.ToArray)
        Me.BriefanredeComboBox.Text = m_Adresse.Briefanrede
    End Sub


#Region " Arbeitsadresse schreiben "
    Private Sub FirmaTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirmaTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Firma = FirmaTextBox.Text
    End Sub

    Private Sub Firma1TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Firma1TextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Firma1 = Firma1TextBox.Text
    End Sub

    Private Sub StellungTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StellungTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Stellung = StellungTextBox.Text
    End Sub

    Private Sub FirmavoranCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirmavoranCheckBox.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Adresse.FirmaVoran = FirmavoranCheckBox.Checked
    End Sub

    Private Sub GeschlechtChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonMaennl.CheckedChanged, RadioButtonWeibl.CheckedChanged, RadioButtonUnpers.CheckedChanged
        If m_Initializing Then Exit Sub
        If Me.RadioButtonMaennl.Checked Then
            m_Adresse.Geschlecht = Geschlechter.maennlich
        ElseIf Me.RadioButtonWeibl.Checked Then
            m_Adresse.Geschlecht = Geschlechter.weiblich
        ElseIf Me.RadioButtonUnpers.Checked Then
            m_Adresse.Geschlecht = Geschlechter.unpersoenlich
        End If
    End Sub

    Private Sub TitelComboBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TitelComboBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Titel = TitelComboBox.Text
    End Sub

    Private Sub NachnameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NachnameTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Nachname = NachnameTextBox.Text
    End Sub

    Private Sub VornameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VornameTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Vorname = VornameTextBox.Text
    End Sub

    Private Sub StrasseTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StrasseTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Strasse = StrasseTextBox.Text
    End Sub

    Private Sub PlzTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlzTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.PLZ = PlzTextBox.Text
    End Sub

    Private Sub OrtTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OrtTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Ort = OrtTextBox.Text
    End Sub

    Private Sub BriefanredeComboBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles BriefanredeComboBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Adresse.Briefanrede = BriefanredeComboBox.Text
    End Sub

    Private Sub GeburtstagValidatedDateTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GeburtstagValidatedDateTextBox.TextChanged
        If m_Initializing Then Exit Sub
        Dim Dat As New ParsedDate(GeburtstagValidatedDateTextBox.Text)
        m_Adresse.Geburtsdatum = Dat.Datum
    End Sub

#End Region

#Region " Handler zum Aendern von TextBox- / ComboBox-Inhalten nach Arbeitsadresse-Events "

    Private Sub m_Adresse_AdressAnsicht_Geaendert() Handles m_Adresse.AdressAnsicht_Geaendert
        Me.TextBoxAdressansicht.Text = m_Adresse.AdressAnsicht
    End Sub


    Private Sub m_Adresse_BriefAnrede_AutomatischGeaendert() Handles m_Adresse.BriefAnrede_AutomatischGeaendert
        m_Initializing = True
        Me.BriefanredeComboBox.Text = m_Adresse.Briefanrede
        m_Initializing = False
    End Sub
    '
    Private Sub m_Adresse_AnredeVorschlaege_Geaendert() Handles m_Adresse.AnredeVorschlaege_Geaendert
        m_Initializing = True
        BriefanredeCombo_Fllen()
        m_Initializing = False
    End Sub
#End Region


    Private Sub m_Titel_Geaendert() Handles m_Titel.Geaendert
        m_Initializing = True
        Me.TitelComboBox.Items.Clear()
        For Each TI As Titel In m_Titel
            TitelComboBox.Items.Add(TI)
        Next
        If m_Adresse IsNot Nothing Then
            TitelComboBox.Text = m_Adresse.Titel
        End If
        m_Initializing = False
    End Sub

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub TitelComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TitelComboBox.SelectedIndexChanged

    End Sub

    Private Sub Adress_Editor_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If m_Adresse IsNot Nothing Then
            TitelComboBox.SelectionLength = 0
            Me.BriefanredeComboBox.SelectionLength = 0
        End If
    End Sub
End Class
