Public Class Stammdaten_Editor
    Private WithEvents m_Titel As TitelListe
    Private m_Patient As Patient
    Private m_Initializing As Boolean = False
    WriteOnly Property Patient() As Patient
        Set(ByVal value As Patient)
            m_Patient = value
            ReadValues()
        End Set
    End Property
 

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Titel = DataProvider.Titel
        For Each TI As Titel In m_Titel
            TitelComboBox.Items.Add(TI)
        Next
    End Sub
    Private Sub ReadValues()
        m_Initializing = True

        If m_Patient IsNot Nothing Then
            Select Case m_Patient.Geschlecht
                Case Geschlechter.maennlich
                    Me.CheckBoxMaennlich.Checked = True
                Case Else
                    Me.CheckBoxMaennlich.Checked = False
            End Select
            Me.TitelComboBox.Text = m_Patient.Titel
            Me.NachnameTextBox.Text = m_Patient.Nachname
            Me.VornameTextBox.Text = m_Patient.Vorname
            Me.OrtTextBox.Text = m_Patient.Ort
            Me.PlzTextBox.Text = m_Patient.PLZ
            Me.StrasseTextBox.Text = m_Patient.Strasse
            Dim MinDatum As New Date(1860, 1, 1)
            If m_Patient.Geburtsdatum < MinDatum Then
                Me.ValidatedDateTextBoxGeburtsdatum.Text = ""
            Else
                Me.ValidatedDateTextBoxGeburtsdatum.Text = m_Patient.Geburtsdatum.ToShortDateString
            End If

            If m_Patient.Aufnahmedatum < MinDatum Then
                Me.ValidatedDateTextBoxAufnahme.Text = ""
            Else
                Me.ValidatedDateTextBoxAufnahme.Text = m_Patient.Aufnahmedatum.ToShortDateString
            End If
            If m_Patient.Entlassungsdatum < MinDatum Then
                Me.ValidatedDateTextBoxEntlassung.Text = ""
            Else
                Me.ValidatedDateTextBoxEntlassung.Text = m_Patient.Entlassungsdatum.ToShortDateString
            End If
            If m_Patient.Vorgeseheneentlassung < MinDatum Then
                Me.ValidatedDateTextBoxVorgeseheneEntlassung.Text = ""
            Else
                Me.ValidatedDateTextBoxVorgeseheneEntlassung.Text = m_Patient.Vorgeseheneentlassung.ToShortDateString
            End If

            Me.EintragsEditor1.Source = m_Patient.FonFax

            Me.Enabled = True
        Else
            Me.CheckBoxMaennlich.Checked = False
            Me.TitelComboBox.Text = ""
            Me.NachnameTextBox.Text = ""
            Me.VornameTextBox.Text = ""
            Me.OrtTextBox.Text = ""
            Me.PlzTextBox.Text = ""
            Me.StrasseTextBox.Text = ""
            Me.ValidatedDateTextBoxGeburtsdatum.Text = ""
            Me.ValidatedDateTextBoxAufnahme.Text = ""
            Me.ValidatedDateTextBoxEntlassung.Text = ""
            Me.ValidatedDateTextBoxVorgeseheneEntlassung.Text = ""
            Me.EintragsEditor1.Source = Nothing
            Me.Enabled = False
        End If

        m_Initializing = False
    End Sub


#Region " Arbeitsadresse schreiben "

    Private Sub CheckBoxMaennlich_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxMaennlich.CheckedChanged
        If m_Initializing Then Exit Sub
        If CheckBoxMaennlich.Checked Then
            m_Patient.Geschlecht = Geschlechter.maennlich
        Else
            m_Patient.Geschlecht = Geschlechter.weiblich
        End If
    End Sub

    Private Sub TitelComboBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TitelComboBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.Titel = TitelComboBox.Text
    End Sub

    Private Sub NachnameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NachnameTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.Nachname = NachnameTextBox.Text
    End Sub

    Private Sub VornameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VornameTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.Vorname = VornameTextBox.Text
    End Sub

    Private Sub StrasseTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StrasseTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.Strasse = StrasseTextBox.Text
    End Sub

    Private Sub PlzTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlzTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.PLZ = PlzTextBox.Text
    End Sub

    Private Sub OrtTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OrtTextBox.TextChanged
        If m_Initializing Then Exit Sub
        m_Patient.Ort = OrtTextBox.Text
    End Sub
    Private Sub ValidatedDateTextBoxGeburtsdatum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ValidatedDateTextBoxGeburtsdatum.TextChanged
        If m_Initializing Then Exit Sub
        Dim Dat As New ParsedDate(ValidatedDateTextBoxGeburtsdatum.Text)
        m_Patient.Geburtsdatum = Dat.Datum
    End Sub
    Private Sub ValidatedDateTextBoxAufnahme_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ValidatedDateTextBoxAufnahme.TextChanged
        If m_Initializing Then Exit Sub
        Dim Dat As New ParsedDate(ValidatedDateTextBoxAufnahme.Text)
        m_Patient.Aufnahmedatum = Dat.Datum
    End Sub

    Private Sub ValidatedDateTextBoxEntlassung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ValidatedDateTextBoxEntlassung.TextChanged
        If m_Initializing Then Exit Sub
        Dim Dat As New ParsedDate(ValidatedDateTextBoxEntlassung.Text)
        m_Patient.Entlassungsdatum = Dat.Datum
    End Sub

    Private Sub ValidatedDateTextBoxVorgeseheneEntlassung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ValidatedDateTextBoxVorgeseheneEntlassung.TextChanged
        If m_Initializing Then Exit Sub
        Dim Dat As New ParsedDate(ValidatedDateTextBoxVorgeseheneEntlassung.Text)
        m_Patient.Vorgeseheneentlassung = Dat.Datum
    End Sub
#End Region

    Private Sub m_Titel_Geaendert() Handles m_Titel.Geaendert
        m_Initializing = True
        Me.TitelComboBox.Items.Clear()
        For Each TI As Titel In m_Titel
            TitelComboBox.Items.Add(TI)
        Next
        If m_Patient IsNot Nothing Then
            TitelComboBox.Text = m_Patient.Titel
        End If
        m_Initializing = False
    End Sub


End Class
