Imports System.Xml
Public Class Anrede
    Private m_Titel As String = ""
    Private m_Synonyme As New List(Of String)
    Private m_Anredemaennlich As String = ""
    Private m_Anredeweiblich As String = ""
    Private m_mitNachname As Boolean = True
    Public Event TitelGeaendert()
    Public Event AnredeMaennlichGeaendert()
    Public Event AnredeWeiblichGeaendert()
    Public Sub New()

    End Sub
    Public Sub New(ByVal Titel As String, ByVal Anredemaennlich As String, ByVal Anredeweiblich As String, ByVal mitNachname As Boolean)
        m_Titel = Titel
        m_Anredemaennlich = Anredemaennlich
        m_Anredeweiblich = Anredeweiblich
        m_mitNachname = mitNachname
    End Sub
    Public Sub New(ByVal Nd As System.Xml.XmlNode)
        m_Titel = Nd.Attributes("Titel").Value
        m_Anredemaennlich = Nd.Attributes("Anredemaennlich").Value
        m_Anredeweiblich = Nd.Attributes("Anredeweiblich").Value
        m_mitNachname = CBool(Nd.Attributes("MitNachname").Value)
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Synonym" Then
                Me.m_Synonyme.Add(xNd.Attributes("Text").Value)
            End If
        Next
    End Sub
    Property Titel() As String
        Get
            Return m_Titel
        End Get
        Set(ByVal Value As String)
            If Value = "" Then
                m_Titel = "???"
            Else
                m_Titel = Value
            End If
            m_Anredemaennlich = "Sehr geehrter Herr " & m_Titel
            m_Anredeweiblich = "Sehr geehrte Frau " & m_Titel
            RaiseEvent TitelGeaendert()
        End Set
    End Property
    ReadOnly Property Synonyme() As List(Of String)
        Get
            Return m_Synonyme
        End Get
    End Property
    Property AnredeMaennlich() As String
        Get
            Return m_Anredemaennlich
        End Get
        Set(ByVal Value As String)
            m_Anredemaennlich = Value
            RaiseEvent AnredeMaennlichGeaendert()
        End Set
    End Property
    Property AnredeWeiblich() As String
        Get
            Return m_Anredeweiblich
        End Get
        Set(ByVal Value As String)
            m_Anredeweiblich = Value
            RaiseEvent AnredeWeiblichGeaendert()
        End Set
    End Property
    Property MitNachname() As Boolean
        Get
            Return m_mitNachname
        End Get
        Set(ByVal Value As Boolean)
            m_mitNachname = Value
            RaiseEvent TitelGeaendert()
        End Set
    End Property
    Public Function MusterAnredeMaennlich() As String
        Dim ZM As String
        If Me.m_mitNachname Then
            ZM = m_Anredemaennlich & " Mustermann,"
        Else
            ZM = m_Anredemaennlich & ","
        End If
        Return ZM
    End Function
    Public Function MusterAnredeWeiblich() As String
        Dim ZM As String
        If Me.m_mitNachname Then
            ZM = m_Anredeweiblich & " Mustermann,"
        Else
            ZM = m_Anredeweiblich & ","
        End If
        Return ZM
    End Function
    Public Overrides Function ToString() As String
        Return m_Titel
    End Function
    Public Sub Write_XML(ByVal writer As System.Xml.XmlTextWriter)
        writer.WriteAttributeString("Titel", m_Titel)
        writer.WriteAttributeString("Anredemaennlich", m_Anredemaennlich)
        writer.WriteAttributeString("Anredeweiblich", m_Anredeweiblich)
        writer.WriteAttributeString("MitNachname", m_mitNachname.ToString)
        For Each Txt As String In m_Synonyme
            writer.WriteStartElement("Synonym")
            writer.WriteAttributeString("Text", Txt)
            writer.WriteEndElement()
        Next
    End Sub
End Class
