Imports System.Xml
Public Class PatientXMLPart
    Inherits Adresse



    Public Function CreateClone() As PatientXMLPart
        Dim NewPart As New PatientXMLPart
       
        NewPart.Nachname = Me.Nachname
        NewPart.Vorname = Me.Vorname
        NewPart.Ort = Me.Ort
        NewPart.PLZ = Me.PLZ
        NewPart.Strasse = Me.Strasse
        NewPart.Firma = Me.Firma
        NewPart.Firma1 = Me.Firma1
        NewPart.Stellung = Me.Stellung
        NewPart.Geburtsdatum = Me.Geburtsdatum
        NewPart.FirmaVoran = Me.FirmaVoran
        NewPart.Geschlecht = Me.Geschlecht
        NewPart.Titel = Me.Titel
        NewPart.Briefanrede = Me.Briefanrede

        Dim Zaehler As Integer = 0
        For Each fx As FonFax In Me.FonFax
            If Not fx.IsEmpty Then
                Dim NewFx As New FonFax(NewPart.FonFax)
                NewFx.Bezeichnung = fx.Bezeichnung
                NewFx.Nummer = fx.Nummer
                NewPart.FonFax.Insert(Zaehler, NewFx)
                Zaehler += 1
            End If
        Next

        NewPart.Kuerzel = Me.Kuerzel
        NewPart.AdressAnsicht = Me.AdressAnsicht

        NewPart.Aufnahmedatum = m_Aufnahmedatum
        NewPart.Vorgeseheneentlassung = m_Vorgeseheneentlassung
        NewPart.Vorrangig = m_Vorrangig

        For Each txt As String In m_Briefe
            NewPart.Briefe.Add(txt)
        Next

        For Each Lbl As ArztLabel In m_Aerzte
            NewPart.Aerzte.Add(Lbl)
        Next

        Return NewPart
    End Function
    Public Sub ReadValues(ByVal Original As PatientXMLPart)
        Me.Nachname = Original.Nachname
        Me.Vorname = Original.Vorname
        Me.Ort = Original.Ort
        Me.PLZ = Original.PLZ
        Me.Strasse = Original.Strasse
        Me.Firma = Original.Firma
        Me.Firma1 = Original.Firma1
        Me.Stellung = Original.Stellung
        Me.Geburtsdatum = Original.Geburtsdatum
        Me.FirmaVoran = Original.FirmaVoran
        Me.Geschlecht = Original.Geschlecht
        Me.Titel = Original.Titel
        Me.Briefanrede = Original.Briefanrede

        Me.FonFax.Clear()
        Dim Zaehler As Integer = 0
        For Each fx As FonFax In Original.FonFax
            If Not fx.IsEmpty Then
                Dim NewFx As New FonFax(Me.FonFax)
                NewFx.Bezeichnung = fx.Bezeichnung
                NewFx.Nummer = fx.Nummer
                Me.FonFax.Insert(Zaehler, NewFx)
                Zaehler += 1
            End If
        Next
        Me.FonFax.ValidateForNewItem()

        Me.Kuerzel = Original.Kuerzel
        Me.AdressAnsicht = Original.AdressAnsicht

        Me.Aufnahmedatum = Original.Aufnahmedatum
        Me.Vorgeseheneentlassung = Original.Vorgeseheneentlassung
        m_Vorrangig = Original.Vorrangig

        m_Briefe.Clear()
        For Each txt As String In Original.Briefe
            m_Briefe.Add(txt)
        Next

        m_Aerzte.Clear()
        For Each Lbl As ArztLabel In Original.Aerzte
            m_Aerzte.Add(Lbl)
        Next
    End Sub

    'Implements ILabelProvider
    'Public Event LabelChanged(ByVal NewValue As String) Implements ILabelProvider.LabelChanged

#Region " Private Fields "
    'Private m_ActiveLabel As String = ""

    Private m_Aufnahmedatum As Date = Date.MinValue
    Private m_Vorgeseheneentlassung As Date = Date.MinValue
    Private m_Vorrangig As Boolean = False

    Private m_Diagnosen As TextEintragsListe
    Private m_Befunde As BefundTextEintragsListe
    Private m_Aufgaben As TextEintragsListe
    Private m_FreiTexte As TextEintragsListe
    Private m_Medikamente As MedikamentVerordnungsListe

    Private m_Aerzte As New List(Of ArztLabel)
    Private m_Briefe As New List(Of String)
#End Region
    ReadOnly Property Briefe() As List(Of String)
        Get
            Return m_Briefe
        End Get
    End Property
    Property Vorrangig() As Boolean
        Get
            Return m_Vorrangig
        End Get
        Set(ByVal value As Boolean)
            m_Vorrangig = value
        End Set
    End Property
    ReadOnly Property Medikamente() As MedikamentVerordnungsListe
        Get
            Return m_Medikamente
        End Get
    End Property
    ReadOnly Property Diagnosen() As TextEintragsListe
        Get
            Return m_Diagnosen
        End Get
    End Property
    ReadOnly Property Befunde() As BefundTextEintragsListe
        Get
            Return m_Befunde
        End Get
    End Property
    ReadOnly Property Aufgaben() As TextEintragsListe
        Get
            Return m_Aufgaben
        End Get
    End Property
    ReadOnly Property FreiTexte() As TextEintragsListe
        Get
            Return m_FreiTexte
        End Get
    End Property
    ReadOnly Property Aerzte() As List(Of ArztLabel)
        Get
            Return m_Aerzte
        End Get
    End Property
    Property Aufnahmedatum() As Date
        Get
            Return m_Aufnahmedatum
        End Get
        Set(ByVal value As Date)
            m_Aufnahmedatum = value
        End Set
    End Property
    Property Vorgeseheneentlassung() As Date
        Get
            Return m_Vorgeseheneentlassung
        End Get
        Set(ByVal value As Date)
            m_Vorgeseheneentlassung = value
        End Set
    End Property

    Public Sub New()
        m_Diagnosen = New TextEintragsListe
        m_Befunde = New BefundTextEintragsListe
        m_Aufgaben = New TextEintragsListe
        m_FreiTexte = New TextEintragsListe
        m_Medikamente = New MedikamentVerordnungsListe
    End Sub
    Public Sub New(ByVal Nd As XmlNode, ByVal Labels As List(Of ArztLabel))
        MyBase.New(Nd)
        'm_ActiveLabel = Nd.Attributes("ActiveLabel").Value
        m_Aufnahmedatum = CDate(Nd.Attributes("Aufnahmedatum").Value)
        m_Vorgeseheneentlassung = CDate(Nd.Attributes("Vorgeseheneentlassung").Value)

        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "FreiTexte" Then
                m_FreiTexte = New TextEintragsListe(xNd)
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Diagnosen" Then
                m_Diagnosen = New TextEintragsListe(xNd)
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Befunde" Then
                m_Befunde = New BefundTextEintragsListe(xNd)
                Exit For
            End If
        Next
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Aufgaben" Then
                m_Aufgaben = New TextEintragsListe(xNd)
                Exit For
            End If
        Next

        Dim Medi_Found As Boolean = False
        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Medikamente" Then
                m_Medikamente = New MedikamentVerordnungsListe(xNd)
                Medi_Found = True
                Exit For
            End If
        Next
        If Not Medi_Found Then
            m_Medikamente = New MedikamentVerordnungsListe
        End If

        For Each Att As XmlAttribute In Nd.Attributes
            If Att.Name = "Vorrangig" Then
                m_Vorrangig = CBool(Att.Value)
                Exit For
            End If
        Next

        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Briefe" Then
                For Each yNd As XmlNode In xNd.ChildNodes
                    If yNd.Name = "Brief" Then
                        Dim Briefname As String = yNd.Attributes("Pfad").Value
                        If IO.File.Exists(DataProvider.BriefePath & "\" & Briefname) Then
                            m_Briefe.Add(Briefname)
                        End If
                    End If
                Next
                Exit For
            End If
        Next


        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "Aerzte" Then
                For Each yNd As XmlNode In xNd.ChildNodes
                    If yNd.Name = "Arzt" Then
                        Dim AID As String = yNd.Attributes("ID").Value
                        For Each Lbl As ArztLabel In Labels
                            If Lbl.ID = AID Then
                                m_Aerzte.Add(Lbl)
                                Exit For
                            End If
                        Next
                    End If
                Next
                Exit For
            End If
        Next
    End Sub
    Public Overrides Sub WriteExtraAttributes(ByVal Writer As System.Xml.XmlTextWriter)
        'Writer.WriteAttributeString("ActiveLabel", m_ActiveLabel)
        Writer.WriteAttributeString("Aufnahmedatum", m_Aufnahmedatum.ToString)
        Writer.WriteAttributeString("Vorgeseheneentlassung", m_Vorgeseheneentlassung.ToString)
    End Sub
    Public Overrides Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Vorrangig", m_Vorrangig.ToString)
        MyBase.Write_XML(Writer)

        Writer.WriteStartElement("FreiTexte")
        m_FreiTexte.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Diagnosen")
        m_Diagnosen.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Befunde")
        m_Befunde.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Aufgaben")
        m_Aufgaben.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Medikamente")
        m_Medikamente.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Briefe")
        For Each Txt As String In m_Briefe
            Writer.WriteStartElement("Brief")
            Writer.WriteAttributeString("Pfad", Txt)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()

        Writer.WriteStartElement("Aerzte")
        For Each Lbl As ArztLabel In m_Aerzte
            If Not Lbl.KurzText = "" Then
                Writer.WriteStartElement("Arzt")
                Writer.WriteAttributeString("ID", Lbl.ID)
                Writer.WriteEndElement()
            End If
        Next
        Writer.WriteEndElement()
    End Sub

End Class
