Imports System.Xml
Public Class VisitenSammlung
    Private m_AktuelleVisite As Visit
    Private m_Visiten As New List(Of Visit)
    Private m_AlleZimmer As New List(Of Zimmer)

    Property AktuelleVisite() As Visit
        Get
            Return m_AktuelleVisite
        End Get
        Set(ByVal value As Visit)
            m_AktuelleVisite = value
        End Set
    End Property
    ReadOnly Property Visiten() As List(Of Visit)
        Get
            Return m_Visiten
        End Get
    End Property
    ReadOnly Property AlleZimmer() As List(Of Zimmer)
        Get
            Return m_AlleZimmer
        End Get
    End Property


    Public Sub New()
        Dim NewViste As New Visit
        NewViste.Bezeichnung = "Visite1"
        m_Visiten.Add(NewViste)
        m_AktuelleVisite = NewViste
    End Sub
    Public Sub New(ByVal Node As XmlNode)
        For Each xKn As XmlNode In Node.ChildNodes
            If xKn.Name = "AlleZimmer" Then
                For Each Nd As XmlNode In xKn.ChildNodes
                    If Nd.Name = "Zimmer" Then
                        m_AlleZimmer.Add(New Zimmer(Nd.Attributes("ZimmerNummer").Value, CInt(Nd.Attributes("AnzahlBetten").Value)))
                    End If
                Next
                Exit For
            End If
        Next


        For Each xKn As XmlNode In Node.ChildNodes
            If xKn.Name = "Visiten" Then
                For Each Nd As XmlNode In xKn.ChildNodes
                    If Nd.Name = "Visite" Then
                        m_Visiten.Add(New Visit(Nd, m_AlleZimmer))
                    End If
                Next
                Exit For
            End If
        Next

        For Each xKn As XmlNode In Node.ChildNodes
            If xKn.Name = "AktuelleVisite" Then
                m_AktuelleVisite = m_Visiten.Item(CInt(xKn.Attributes("Idx").Value))
                Exit For
            End If
        Next

    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)

        Writer.WriteStartElement("AlleZimmer")
        For Each Zi As Zimmer In m_AlleZimmer
            Writer.WriteStartElement("Zimmer")
            Writer.WriteAttributeString("ZimmerNummer", Zi.ZimmerNummer)
            Writer.WriteAttributeString("AnzahlBetten", Zi.AnzahlBetten.ToString)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()

        Writer.WriteStartElement("Visiten")
        For Each Vis As Visit In m_Visiten
            Writer.WriteStartElement("Visite")
            Vis.XML_Schreiben(Writer, m_AlleZimmer)
            Writer.WriteEndElement()
        Next
        Writer.WriteEndElement()

        Writer.WriteStartElement("AktuelleVisite")
        Writer.WriteAttributeString("Idx", m_Visiten.IndexOf(m_AktuelleVisite).ToString)
        Writer.WriteEndElement()

    End Sub
    Public Sub New(ByVal Sammlung As VisitenSammlung)
      
        For Each Zi As Zimmer In Sammlung.AlleZimmer
            m_AlleZimmer.Add(New Zimmer(Zi.ZimmerNummer, Zi.AnzahlBetten))
        Next
        For Each Vis As Visit In Sammlung.Visiten
            Dim NewVis As New Visit
            NewVis.Bezeichnung = Vis.Bezeichnung
            For Each Zi As Zimmer In Vis.ZugeordneteZimmer
                NewVis.ZugeordneteZimmer.Add(m_AlleZimmer(Sammlung.AlleZimmer.IndexOf(Zi)))
            Next
            m_Visiten.Add(NewVis)
        Next
        m_AktuelleVisite = m_Visiten(Sammlung.Visiten.IndexOf(Sammlung.AktuelleVisite))
    End Sub

End Class
