Imports System.Xml
Public Class BefundStichwortListe
    Inherits List(Of BefundStichwort)
    Public Event Changed()

    Private m_ShortWordsLower As List(Of String)
    Private m_ShortWordsNormal As List(Of String)
    Private m_AutoCompleteCollection As New AutoCompleteStringCollection
    ReadOnly Property ShortWordsLower() As List(Of String)
        Get
            Return m_ShortWordsLower
        End Get
    End Property
    ReadOnly Property ShortWordsNormal() As List(Of String)
        Get
            Return m_ShortWordsNormal
        End Get
    End Property
    ReadOnly Property AutoCompleteCollection() As AutoCompleteStringCollection
        Get
            Return m_AutoCompleteCollection
        End Get
    End Property
    Private Sub ReCreateCommonLists()
        m_AutoCompleteCollection = New AutoCompleteStringCollection
        m_ShortWordsLower = New List(Of String)
        m_ShortWordsNormal = New List(Of String)
        For Each Wd As BefundStichwort In Me
            m_AutoCompleteCollection.Add(Wd.KurzWort)
            m_ShortWordsLower.Add(Wd.KurzWort.ToLower)
            m_ShortWordsNormal.Add(Wd.KurzWort)
        Next
    End Sub
    Public Sub Edit()
        Dim frm As New frm_BefundStichwortEditor(Me)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.Clear()
            For Each Stw As BefundStichwort In frm.ListBoxStichworte.Items
                Me.Add(Stw)
            Next
            ReCreateCommonLists()
            RaiseEvent Changed()
        End If
    End Sub
    Public Sub Edit(ByVal NewWord As String)
        Dim frm As New frm_BefundStichwortEditor(Me)
        Dim Wort As New BefundStichwort
        Wort.KurzWort = NewWord
        'Wort.Wort = NewWord
        frm.ListBoxStichworte.Items.Add(Wort)
        frm.ListBoxStichworte.SelectedItem = Wort
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.Clear()
            For Each Stw As BefundStichwort In frm.ListBoxStichworte.Items
                Me.Add(Stw)
            Next
            ReCreateCommonLists()
            RaiseEvent Changed()
        End If
    End Sub
    Public Sub New(ByVal xKn As XmlNode)
        For Each Nd As XmlNode In xKn.ChildNodes
            If Nd.Name = "BefundStichwort" Then
                Me.Add(New BefundStichwort(Nd))
            End If
        Next
        ReCreateCommonLists()
    End Sub
    Public Sub New()
        Me.Add(New BefundStichwort("Abdomensonografie", "Sono", True, True))
        Me.Add(New BefundStichwort("Sonografie der Schilddrse", "Sono SD", False, False))

        Me.Add(New BefundStichwort("Rntgen-Thorax", "R Thorax", False, False))
        Me.Add(New BefundStichwort("Gastroskopie", "Gastro", False, False))
        Me.Add(New BefundStichwort("Coloskopie", "Colo", False, False))
        Me.Add(New BefundStichwort("Endosonografie", "EndoSono", False, False))
        Me.Add(New BefundStichwort("Endoskopische Retrograde Cholangio-Pankreatikografie", "ERCP", False, False))
        ReCreateCommonLists()
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each StW As BefundStichwort In Me
            Writer.WriteStartElement("BefundStichwort")
            StW.WriteXML(Writer)
            Writer.WriteEndElement()
        Next
    End Sub
    'Public Function GetWords() As System.Collections.Generic.List(Of String) Implements IWortListe.GetWords
    '    Dim Result As New List(Of String)
    '    For Each Wd As BefundStichwort In Me
    '        Result.Add(Wd.KurzWort)
    '    Next
    '    Return Result
    'End Function
End Class

