Public Class TippArea
    Inherits PrintArea
    Private m_Font As Font
    Private m_StringGroups As New List(Of ColorStringGroup)
    Private m_FullHeight As Single
    Private m_LineHeights As List(Of Single)

    Public Overrides Function GetNeededHeight(ByVal g As System.Drawing.Graphics, ByVal Width As Single) As Single

        If m_LineHeights Is Nothing Then
            m_LineHeights = New List(Of Single)
            m_FullHeight = m_Font.GetHeight(g)
            For Each grp As ColorStringGroup In m_StringGroups
                Dim Height As Single = grp.GetHeight(g, Width)
                m_LineHeights.Add(Height)
                m_FullHeight += Height
            Next
        End If

        Return m_FullHeight
    End Function

    Public Overrides Sub Print(ByVal g As System.Drawing.Graphics, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single)
        Dim xTop As Single = Top + m_Font.GetHeight(g)
        g.DrawString("Tipps", m_Font, New SolidBrush(ColorLib.ZimmerColor), Left, Top)

        For I As Integer = 0 To m_StringGroups.Count - 1
            m_StringGroups(I).Print(g, Left, xTop, Width)
            xTop += m_LineHeights(I)
        Next

    End Sub

    Public Sub New()
        m_Font = New Font("Arial", 8)

        Dim Alternator As New ColorAlternator(ColorLib.NormalColor, ColorLib.WarningColor)

        For Each Rw As TextEintrag In DataProvider.Tipps
            If Not Rw.IsEmpty Then
                Dim Gr As New ColorStringGroup(m_Font)
                Gr.Add(Rw.Text, Alternator.NormalColor)
                m_StringGroups.Add(Gr)
                Alternator.Alternate()
            End If
        Next

    End Sub
End Class

