Public Class VisiteDruckSammlung

    Private m_Areas As New List(Of PrintArea)


    Public Sub New()
        CreateAreas()
    End Sub
    ReadOnly Property Areas() As List(Of PrintArea)
        Get
            Return m_Areas
        End Get
    End Property


    Private Sub CreateAreas()
        Dim AktuellePatienten As List(Of Patient) = DataProvider.PatientProvider.TempAktuellePatienten
        AktuellePatienten.Sort(New PatientenBettComparer)

        Dim ZiAreaOhneZimmer As New PatientenZimmerArea("Ohne Zimmer")

        For Each Zi As Zimmer In DataProvider.Visiten.AktuelleVisite.ZugeordneteZimmer
            Dim ZiArea As New PatientenZimmerArea(Zi.ZimmerNummer.Trim)
            m_Areas.Add(ZiArea)
        Next

        Dim Found As Boolean
        For Each Pat As Patient In AktuellePatienten
            Found = False
            For Each ZAr As PatientenZimmerArea In m_Areas
                If Pat.Zimmernummer.Trim.ToLower = ZAr.ZimmerNr.ToLower Then
                    ZAr.PatientAreas.Add(New PatientArea(Pat))
                    Found = True
                    Exit For
                End If
            Next
            If Not Found Then
                ZiAreaOhneZimmer.PatientAreas.Add(New PatientArea(Pat))
            End If
        Next

        If ZiAreaOhneZimmer.PatientAreas.Count > 0 Then
            m_Areas.Add(ZiAreaOhneZimmer)
        End If

    End Sub

    Public Sub SplitLangeZimmerForHeight(ByVal g As Graphics, ByVal Width As Integer, ByVal Height As Integer)
        Dim OldAreas As New List(Of PatientenZimmerArea)
        Dim NewAreas As New List(Of PatientenZimmerArea)
        For Each Area As PatientenZimmerArea In m_Areas
            OldAreas.Add(Area)
        Next
        For Each Area As PatientenZimmerArea In OldAreas
            If Area.GetNeededHeight(g, Width) < Height Then
                NewAreas.Add(Area)
            Else
                Dim NewArea As New PatientenZimmerArea(Area.ZimmerNr)
                NewAreas.Add(NewArea)

                While Area.PatientAreas.Count > 0
                    NewArea.PatientAreas.Add(Area.PatientAreas(0))

                    If NewArea.GetNeededHeight(g, Width) > Height AndAlso NewArea.PatientAreas.Count > 1 Then
                        NewArea.PatientAreas.Remove(Area.PatientAreas(0))
                        NewArea = New PatientenZimmerArea(Area.ZimmerNr)
                        NewAreas.Add(NewArea)
                        NewArea.PatientAreas.Add(Area.PatientAreas(0))
                    End If
                    Area.PatientAreas.RemoveAt(0)
                End While
            End If
        Next

        m_Areas.Clear()
        For Each area As PatientenZimmerArea In NewAreas
            m_Areas.Add(area)
        Next
    End Sub
End Class

