Public Class frm_Aerzte_Auswaehlen

    Private WithEvents m_Provider As ArztProvider

    Private m_TopPainter As New HighlightPainter
    Private m_BottomPainter As New HighlightPainter

    Private Sub frm_Aerzte_Auswaehlen_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Me.PanelLeft.Width = (Me.Width - 43) \ 2
        Me.ListViewArztauswahl.Columns(0).Width = -2
        Me.ListViewZugeordnete_Aerzte.Columns(0).Width = -2

    End Sub
 


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.AcceptButton = Me.OkAbortPanel1.ButtonOK
        Me.CancelButton = Me.OkAbortPanel1.ButtonAbbrechen
        m_Provider = DataProvider.ArztProvider
        Refill_SuchVorschlaege()

        Dim IL As New ImageList
        IL.ImageSize = New Size(14, 14)
        IL.ColorDepth = ColorDepth.Depth32Bit
        IL.Images.Add(My.Resources.Mann)
        IL.Images.Add(My.Resources.Frau)
        IL.Images.Add(My.Resources.unpers)

        Me.ListViewArztauswahl.SmallImageList = IL
        Me.ListViewZugeordnete_Aerzte.SmallImageList = IL

        m_TopPainter.Color = SystemColors.Control
        m_BottomPainter.Color = SystemColors.Control

        Me.Controls.Add(m_TopPainter)
        Me.Controls.Add(m_BottomPainter)
        m_TopPainter.BringToFront()
        m_BottomPainter.BringToFront()
    End Sub


    Private Sub SelectArzt(ByVal PreferredListView As ListView)

        'Private m_TopPainter As New HighlightPainter
        'Private m_BottomPainter As New HighlightPainter

        Dim OtherListView As ListView
        If PreferredListView Is ListViewZugeordnete_Aerzte Then
            OtherListView = Me.ListViewArztauswahl
        Else
            OtherListView = ListViewZugeordnete_Aerzte
        End If

        If PreferredListView.SelectedItems.Count > 0 Then
            Dim LVI As ArztLabelListViewItem = PreferredListView.SelectedItems(0)
            LVI.Lbl.SetActive()
        ElseIf OtherListView.SelectedItems.Count > 0 Then
            Dim LVI As ArztLabelListViewItem = OtherListView.SelectedItems(0)
            LVI.Lbl.SetActive()
        Else
            DataProvider.ArztProvider.SetActive(Nothing)
        End If

        If DataProvider.ArztProvider.ActiveEditArzt Is Nothing Then
            Me.TextBoxAdressansicht.Text = ""
            m_TopPainter.Color = SystemColors.Control
            m_BottomPainter.Color = SystemColors.Control
        Else
            Me.TextBoxAdressansicht.Text = DataProvider.ArztProvider.ActiveEditArzt.AdressAnsicht
            m_TopPainter.Color = Color.Red
            m_BottomPainter.Color = Color.Red
        End If


    End Sub

    Private Sub ListViewZugeordnete_Aerzte_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewZugeordnete_Aerzte.Enter
        SelectArzt(ListViewZugeordnete_Aerzte)
    End Sub

    Private Sub ListViewZugeordnete_Aerzte_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewZugeordnete_Aerzte.SelectedIndexChanged
        If ListViewZugeordnete_Aerzte.SelectedItems.Count > 0 Then
            Me.ButtonDelete.Enabled = True
            If ListViewZugeordnete_Aerzte.SelectedItems(0).Index = 0 Then
                Me.UpDownPanel1.ButtonMoveUp.Enabled = False
            Else
                Me.UpDownPanel1.ButtonMoveUp.Enabled = True
            End If
            If ListViewZugeordnete_Aerzte.SelectedItems(0).Index = ListViewZugeordnete_Aerzte.Items.Count - 1 Then
                Me.UpDownPanel1.ButtonMoveDown.Enabled = False
            Else
                Me.UpDownPanel1.ButtonMoveDown.Enabled = True
            End If

            Dim ActiveLVI As ArztLabelListViewItem = ListViewZugeordnete_Aerzte.SelectedItems(0)
            For Each LVI As ArztLabelListViewItem In Me.ListViewArztauswahl.Items
                If LVI.Lbl Is ActiveLVI.Lbl Then
                    LVI.Selected = True
                    LVI.EnsureVisible()
                    Exit For
                End If
            Next

        Else
            Me.ButtonDelete.Enabled = False
            Me.UpDownPanel1.ButtonMoveDown.Enabled = False
            Me.UpDownPanel1.ButtonMoveUp.Enabled = False
        End If
        SelectArzt(ListViewZugeordnete_Aerzte)
    End Sub

    Private Sub ListViewArztauswahl_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewArztauswahl.Enter
        SelectArzt(ListViewArztauswahl)
    End Sub

    Private Sub ListViewArztauswahl_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewArztauswahl.SelectedIndexChanged
        If ListViewArztauswahl.SelectedItems.Count > 0 Then
            Me.ButtonMoveLeft.Enabled = True
            Me.CommandPanel1.DeleteEnabled = True
            Me.CommandPanel1.EditEnabled = True
        Else
            Me.ButtonMoveLeft.Enabled = False
            Me.CommandPanel1.DeleteEnabled = False
            Me.CommandPanel1.EditEnabled = False
        End If
        SelectArzt(ListViewArztauswahl)
    End Sub

    Private Sub CommandPanel1_AddNew() Handles CommandPanel1.AddNew
        m_Provider.CreateNewArzt()
    End Sub
    Private Sub CommandPanel1_Delete() Handles CommandPanel1.Delete
        If ListViewArztauswahl.SelectedItems.Count = 0 Then Exit Sub
        If MessageBox.Show("Arzt wirklich lschen?", "Visite", MessageBoxButtons.YesNo, MessageBoxIcon.Warning) = Windows.Forms.DialogResult.No Then Exit Sub
        Dim LVI As ArztLabelListViewItem = ListViewArztauswahl.SelectedItems(0)
        LVI.Lbl.SetActive()
        m_Provider.DeleteActiveArzt()
    End Sub

    Private Sub CommandPanel1_Edit() Handles CommandPanel1.Edit
        If ListViewArztauswahl.SelectedItems.Count = 0 Then Exit Sub
        Dim LVI As ArztLabelListViewItem = ListViewArztauswahl.SelectedItems(0)
        m_Provider.SetActive(LVI.Lbl)
        m_Provider.EditActiveArzt()
        SelectArzt(ListViewArztauswahl)
    End Sub
   
    Private Sub m_Provider_ActiveArztAdded() Handles m_Provider.ActiveArztAdded
        If Me.TextBoxSuche.Text.Trim <> "" Then
            TextBoxSuche.Text = ""
        Else
            Refill_SuchVorschlaege()
        End If
        For Each Item As ArztLabelListViewItem In Me.ListViewArztauswahl.Items
            If Item.Lbl Is m_Provider.ActiveEditArzt.Label Then
                Item.Selected = True
                Item.EnsureVisible()
                Exit For
            End If
        Next
    End Sub
    Private Sub Refill_SuchVorschlaege()
        m_Provider.Sort(New ArztLabelComparer)
        m_Provider.Geaendert = True
        Me.ListViewArztauswahl.Items.Clear()
        If Me.TextBoxSuche.Text.Trim <> "" Then
            Dim Teile() As String = Me.TextBoxSuche.Text.Trim.ToLower.Split
            For Each Lbl As ArztLabel In m_Provider
                Dim LowerText As String = Lbl.KurzText.ToLower

                Dim Found As Boolean = True
                For Each text As String In Teile
                    If LowerText.IndexOf(text) = -1 Then
                        Found = False
                        Exit For
                    End If
                Next
                If Found Then
                    Me.ListViewArztauswahl.Items.Add(New ArztLabelListViewItem(Lbl))
                End If
            Next
        Else
            For Each Lbl As ArztLabel In m_Provider
                Me.ListViewArztauswahl.Items.Add(New ArztLabelListViewItem(Lbl))
            Next
        End If
        Me.ButtonMoveLeft.Enabled = False
        Me.CommandPanel1.DeleteEnabled = False
        Me.CommandPanel1.EditEnabled = False
    End Sub

    Private Sub ButtonMoveLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMoveLeft.Click
        If Me.ListViewArztauswahl.SelectedItems.Count > 0 Then
            Dim Itm As ArztLabelListViewItem = ListViewArztauswahl.SelectedItems(0)
            Dim Found As Boolean = False
            For Each xItm As ArztLabelListViewItem In Me.ListViewZugeordnete_Aerzte.Items
                If xItm.Lbl Is Itm.Lbl Then
                    Found = True
                    Exit For
                End If
            Next
            If Not Found Then
                Dim NewItem As New ArztLabelListViewItem(Itm.Lbl)
                Me.ListViewZugeordnete_Aerzte.Items.Add(NewItem)
                NewItem.Selected = True
            End If
        End If
    End Sub

    Private Sub ButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDelete.Click
        If ListViewZugeordnete_Aerzte.SelectedItems.Count = 0 Then Exit Sub
        Dim SelItm As ArztLabelListViewItem = ListViewZugeordnete_Aerzte.SelectedItems(0)
        SelItm.Remove()

    End Sub

    Private Sub UpDownPanel1_MoveDown() Handles UpDownPanel1.MoveDown
        If ListViewZugeordnete_Aerzte.SelectedItems.Count = 0 Then Exit Sub

        Dim SelItm As ArztLabelListViewItem = ListViewZugeordnete_Aerzte.SelectedItems(0)
        Dim Idx As Integer = SelItm.Index
        ListViewZugeordnete_Aerzte.Items.RemoveAt(Idx)
        ListViewZugeordnete_Aerzte.Items.Insert(Idx + 1, SelItm)
        SelItm.Selected = True
    End Sub

    Private Sub UpDownPanel1_MoveUp() Handles UpDownPanel1.MoveUp
        If ListViewZugeordnete_Aerzte.SelectedItems.Count = 0 Then Exit Sub

        Dim SelItm As ArztLabelListViewItem = ListViewZugeordnete_Aerzte.SelectedItems(0)
        Dim Idx As Integer = SelItm.Index
        ListViewZugeordnete_Aerzte.Items.RemoveAt(Idx)
        ListViewZugeordnete_Aerzte.Items.Insert(Idx - 1, SelItm)
        SelItm.Selected = True
    End Sub

 
    'Private Sub ToolStripButtonExcelImport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButtonExcelImport.Click
    '    Try
    '        Dim dlg As New OpenFileDialog
    '        If dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
    '            Dim Nd As Xml.XmlNode = DataProvider.GetXML(dlg.FileName)
    '            For Each xnd As Xml.XmlNode In Nd.ChildNodes
    '                If xnd.Name = "Adresse" Then
    '                    Dim AdrXML As New ArztXMLPart(xnd)
    '                    DataProvider.ArztProvider.AddNew_From_XMLPart(AdrXML)
    '                End If
    '            Next
    '        End If
    '    Catch ex As Exception

    '    End Try

    'End Sub

    Private Sub TextBoxSuche_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxSuche.TextChanged
        If TextBoxSuche.Text.Trim = "" Then
            ButtonSuche.Text = "Suchen"
        Else
            ButtonSuche.Text = "Alle"
        End If
        Refill_SuchVorschlaege()
    End Sub

    Private Sub ButtonSuche_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSuche.Click
        TextBoxSuche.Text = ""
    End Sub
End Class