Public Class frm_SpezialSuche
    Private m_Einstellungen As SuchEinstellungen
    Private m_Initializing As Boolean = False
    Private Vorhandene As List(Of String)
    Public Sub New(ByVal Einstellungen As SuchEinstellungen)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.AcceptButton = Me.OkAbortPanel1.ButtonOK
        Me.CancelButton = Me.OkAbortPanel1.ButtonAbbrechen
        m_Einstellungen = Einstellungen
        ReadEinstellungen()
    End Sub
    Private Sub ReadEinstellungen()
        m_Initializing = True

        Vorhandene = DataProvider.BefundStichworte.ShortWordsNormal

        Dim ZuLoeschende As New List(Of String)
        For Each txt As String In m_Einstellungen.SelectedBefunde
            If Not Vorhandene.Contains(txt) Then
                ZuLoeschende.Add(txt)
            End If
        Next

        For Each txt As String In ZuLoeschende
            m_Einstellungen.SelectedBefunde.Remove(txt)
        Next

        For Each txt As String In Vorhandene
            If m_Einstellungen.SelectedBefunde.Contains(txt) Then
                Me.CheckedListBoxBefundAuswahl.Items.Add(txt, True)
            Else
                Me.CheckedListBoxBefundAuswahl.Items.Add(txt, False)
            End If
        Next

        Select Case m_Einstellungen.ZeitBereich
            Case SuchEinstellungsZeitbereiche.Aktuelle
                Me.RadioButtonZB_Aktuell.Checked = True
            Case SuchEinstellungsZeitbereiche.Alle
                Me.RadioButtonZB_Alle.Checked = True
            Case SuchEinstellungsZeitbereiche.Entlassene
                Me.RadioButtonZB_Entlassen.Checked = True
            Case SuchEinstellungsZeitbereiche.VierzehnTage
                Me.RadioButtonZB_Vierzehn.Checked = True
        End Select

        Select Case m_Einstellungen.BefundAuswahl
            Case SuchEinstellungsBefundAuswahlen.FehlendUndLeer
                Me.RadioButtonSN_FehlUndLeer.Checked = True
            Case SuchEinstellungsBefundAuswahlen.Leer
                Me.RadioButtonSN_Leer.Checked = True
            Case SuchEinstellungsBefundAuswahlen.Befunde
                Me.RadioButtonSN_Befund.Checked = True
        End Select

        If Me.CheckedListBoxBefundAuswahl.CheckedItems.Count = 0 Then
            Me.OkAbortPanel1.ButtonOK.Enabled = False
        End If
        m_Initializing = False
    End Sub

    Private Sub CheckedListBoxBefundAuswahl_ItemCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckEventArgs) Handles CheckedListBoxBefundAuswahl.ItemCheck
        If m_Initializing Then Exit Sub
        Dim txt As String = Vorhandene(e.Index)
        If e.NewValue = CheckState.Checked Then
            If Not m_Einstellungen.SelectedBefunde.Contains(txt) Then
                m_Einstellungen.SelectedBefunde.Add(txt)
            End If
        Else
            If m_Einstellungen.SelectedBefunde.Contains(txt) Then
                m_Einstellungen.SelectedBefunde.Remove(txt)
            End If
        End If
        If m_Einstellungen.SelectedBefunde.Count = 0 Then
            Me.OkAbortPanel1.ButtonOK.Enabled = False
        Else
            Me.OkAbortPanel1.ButtonOK.Enabled = True
        End If
    End Sub

   
    Private Sub RadioButtonZB_Aktuell_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonZB_Aktuell.CheckedChanged, RadioButtonZB_Alle.CheckedChanged, RadioButtonZB_Entlassen.CheckedChanged, RadioButtonZB_Vierzehn.CheckedChanged
        If m_Initializing Then Exit Sub
        If Me.RadioButtonZB_Aktuell.Checked Then
            m_Einstellungen.ZeitBereich = SuchEinstellungsZeitbereiche.Aktuelle
        ElseIf Me.RadioButtonZB_Alle.Checked Then
            m_Einstellungen.ZeitBereich = SuchEinstellungsZeitbereiche.Alle
        ElseIf Me.RadioButtonZB_Entlassen.Checked Then
            m_Einstellungen.ZeitBereich = SuchEinstellungsZeitbereiche.Entlassene
        ElseIf Me.RadioButtonZB_Vierzehn.Checked Then
            m_Einstellungen.ZeitBereich = SuchEinstellungsZeitbereiche.VierzehnTage
        End If
    End Sub

    Private Sub RadioButtonSN_FehlUndLeer_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonSN_FehlUndLeer.CheckedChanged
        If m_Initializing Then Exit Sub
        If Me.RadioButtonSN_FehlUndLeer.Checked Then
            m_Einstellungen.BefundAuswahl = SuchEinstellungsBefundAuswahlen.FehlendUndLeer
        ElseIf Me.RadioButtonSN_Leer.Checked Then
            m_Einstellungen.BefundAuswahl = SuchEinstellungsBefundAuswahlen.Leer
        ElseIf Me.RadioButtonSN_Befund.Checked Then
            m_Einstellungen.BefundAuswahl = SuchEinstellungsBefundAuswahlen.Befunde
        End If
    End Sub
End Class